#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "tstst.h"
#include "tmpvar.h"
#include "semerr.h"
#include "bodypars.h"

extern YYSTYPE yylval;
extern struct PBGLOBAL *SemGlobal;

void NewFullAlias(void)
{
	if(SemGlobal->AliasCnt)
	{
		SemGlobal->FullListForAlias=(ALIASINF*)realloc(
			(ALIASINF*)SemGlobal->FullListForAlias,
			sizeof(ALIASINF)*(SemGlobal->AliasCnt+1));
	}
	else
	{
		SemGlobal->FullListForAlias=(ALIASINF*)malloc(sizeof(ALIASINF));
	}
}

void FreeListForAlias(void)
{
	if(SemGlobal->ListForAlias!=NULL)
	{
		free(SemGlobal->ListForAlias);
		SemGlobal->ListForAlias=NULL;
	}
}//FreeListForAlias


void FreeFullListForAlias(void)
{
	int i;
	if(SemGlobal->AliasCnt)
	{
		for(i=0 ; i<SemGlobal->AliasCnt ; i++)
			free(SemGlobal->FullListForAlias[i].right);
		free(SemGlobal->FullListForAlias);
		SemGlobal->FullListForAlias=NULL;
		SemGlobal->AliasCnt=0;
	}
}//FreeFullListForAlias


void AliasCheckAndReplace(char *bufor)
{
	int i, j, value;
	for(i=0 ; i<SemGlobal->AliasCnt ; i++)
	{
		if(!stricmp(SemGlobal->FullListForAlias[i].left, bufor))
		{
			strcpy(bufor, SemGlobal->FullListForAlias[i].right[0].tokstr);
			for(j=1 ; j<SemGlobal->FullListForAlias[i].rightlen ; j++)
			{
				strcat(bufor, SemGlobal->FullListForAlias[i].right[j].tokstr);
			}
		}
	}
	value=getvalue(bufor, NULL);
	if(value<200)
		return;
	for(i=0 ; i<SemGlobal->ModifiersCnt.real ; i++)
	{
		if(value==SemGlobal->Modifiers[i].origlexno && SemGlobal->varlevel >= SemGlobal->Modifiers[i].level)
		{
			if(SemGlobal->Modifiers[i].ComponName && SemGlobal->isArchitectureParsed)
			{
				if(SemGlobal->actEntityContext[0]!=0 && !stricmp(SemGlobal->Modifiers[i].ComponName, SemGlobal->actEntityContext))
				{
					if(SemGlobal->actProcessContext[0]!=0)
					{
						sprintf(bufor, "%d\tidentifier:\t%s\n",
							SemGlobal->Modifiers[i].modlexno,
							SemGlobal->Modifiers[i].ModifiedName);
						if(SemGlobal->Modifiers[i].ProcessName && !stricmp(SemGlobal->Modifiers[i].ProcessName, SemGlobal->actProcessContext))
							break;
					}
					else
					{
						sprintf(bufor, "%d\tidentifier:\t%s\n",
							SemGlobal->Modifiers[i].modlexno,
							SemGlobal->Modifiers[i].ModifiedName);
						break;
					}
				}
			}
			else
				sprintf(bufor, "%d\tidentifier:\t%s\n",
					SemGlobal->Modifiers[i].modlexno,
					SemGlobal->Modifiers[i].ModifiedName);
		}
	}
}//AliasCheckAndReplace

void FindLexemInPackage(char *RealPath, char *line, char *tokstr)
{
	FILE *f;
	int toknum;
	char bufor[BUFSIZE], ltokstr[NAMESIZE], name[NAMESIZE];
	*line=0;
	getname(tokstr, name);
	if(f=fopen(RealPath, "rt"))
	{
		while(fgets(bufor, BUFSIZE, f))
		{
			sscanf(bufor, "%d %s", &toknum, ltokstr);
			if(!stricmp(ltokstr, name))
			{
				strcpy(line, bufor);
				break;
			}
		}
		fclose(f);
	}
}//FindLexemInformation

void FindEnumInPackage(char *RealPath, char *line, char *tokstr)
{
	FILE *f;
	int toknum, value;
	char bufor[BUFSIZE], ltokstr[NAMESIZE], name[NAMESIZE];
	*line=0;
	getname(tokstr, name);
	value=getvalue(tokstr, NULL);
	if(f=fopen(RealPath, "rt"))
	{
		while(fgets(bufor, BUFSIZE, f))
		{
			sscanf(bufor, "%d %s", &toknum, ltokstr);
			if(toknum==value)
			{
				strcpy(line, bufor);
				break;
			}
		}
		fclose(f);
	}
}//FindEnumInPackage

void CheckNewName(char *NewName, int *lexno, int What)
{
	int i, j, mnr;
	int ComponNr, ModifierNr, isModifiedInComponent=0;
	if(SemGlobal->NamesCnt)
		SemGlobal->NamesToCheck=
			(ALLNAMES*)realloc((ALLNAMES*)SemGlobal->NamesToCheck,
			(SemGlobal->NamesCnt+1)*sizeof(ALLNAMES));
	else
		SemGlobal->NamesToCheck=
			(ALLNAMES*)malloc(sizeof(ALLNAMES));
	SemGlobal->NamesToCheck[SemGlobal->NamesCnt].varname=strdup(NewName);
	SemGlobal->NamesToCheck[SemGlobal->NamesCnt].level=SemGlobal->varlevel;
	SemGlobal->NamesToCheck[SemGlobal->NamesCnt].compon=NULL;
	if(What==COMPONV)
		SemGlobal->NamesToCheck[SemGlobal->NamesCnt].compon=strdup(SemGlobal->actcompo);
	else
	{
		for(i=0 ; i<SemGlobal->ChangedComcnt ; i++)
		{
			if(SemGlobal->ileencji && !stricmp(SemGlobal->entities[SemGlobal->ileencji-1].name, SemGlobal->ChangedCom[i].name))
			{
				for(j=0 ; j<SemGlobal->ChangedCom[i].modifierscnt ; j++)
				{
					if(*lexno==SemGlobal->ChangedCom[i].modifiers[j].origlexno)
					{
						isModifiedInComponent=1;
						ComponNr=i;
						ModifierNr=j;
						break;
					}
				}
				break;
			}
		}
	}
	for( i=0 ; i<SemGlobal->NamesCnt ; i++)
	{
		if(!stricmp(NewName, SemGlobal->NamesToCheck[i].varname) || isModifiedInComponent)
		{
			if(SemGlobal->NamesToCheck[i].compon)
			{
				if(What!=COMPONV)
				{
					if(!stricmp(SemGlobal->entities[SemGlobal->ileencji-1].name, SemGlobal->NamesToCheck[i].compon))
						break;
					//nie modfyfikujemy, jesli nazwa wystapila w componencie o takiej
					//samej nazwie oznacza to, ze nie nastapila podmiana
					
					//kontynuujemy przegladania nazw, bo np.
					//mogla wystapic juz jednostka z taka nazwa
				}
				else
				{
					if(SemGlobal->actcompo && !stricmp(SemGlobal->actcompo, SemGlobal->NamesToCheck[i].compon))
						break;
					//nie modyfikujemy w przypadku kiedy byl juz component o tej samej nazwie
					//a nie bylo jeszcze odpowiadajacej mu jednostki
				}

			}
			if(SemGlobal->ModifiersCnt.real)
			{
				if((SemGlobal->ModifiersCnt.real+1)>SemGlobal->ModifiersCnt.last)
				{
					SemGlobal->ModifiersCnt.last<<=1;
					SemGlobal->Modifiers=
						(MODIFIERS*)realloc((MODIFIERS*)SemGlobal->Modifiers,
						(SemGlobal->ModifiersCnt.last)*sizeof(MODIFIERS));
				}
			}
			else
			{
				SemGlobal->Modifiers=
					(MODIFIERS*)malloc(sizeof(MODIFIERS));
				SemGlobal->ModifiersCnt.last=1;
			}
			SemGlobal->Modifiers[SemGlobal->ModifiersCnt.real].level=SemGlobal->varlevel;
			SemGlobal->Modifiers[SemGlobal->ModifiersCnt.real].isInArchitecture=
				SemGlobal->isArchitectureParsed;
			mnr=SemGlobal->ModifiersCnt.real;
			if(isModifiedInComponent)
			{
				SemGlobal->Modifiers[mnr].origlexno=*lexno;
				strcpy(SemGlobal->Modifiers[mnr].ModifiedName,
					SemGlobal->ChangedCom[ComponNr].modifiers[ModifierNr].ModifiedName);
				WriteLastLexemId(SemGlobal->Modifiers[mnr].ModifiedName);
				*lexno=SemGlobal->ChangedCom[ComponNr].modifiers[ModifierNr].modlexno;
				SemGlobal->Modifiers[mnr].modlexno=*lexno;
				strcpy(NewName, SemGlobal->Modifiers[mnr].ModifiedName);
			}
			else
			{
				SemGlobal->Modifiers[mnr].origlexno=*lexno;
				sprintf(SemGlobal->Modifiers[mnr].ModifiedName,
					"__%s_modif__%d", NewName, mnr);
				WriteLastLexemId(SemGlobal->Modifiers[mnr].ModifiedName);
				*lexno=SemGlobal->LastLexemId+199;
				SemGlobal->Modifiers[mnr].modlexno=*lexno;
				strcpy(NewName, SemGlobal->Modifiers[mnr].ModifiedName);
			}
			SemGlobal->Modifiers[mnr].ComponName=NULL;
			SemGlobal->Modifiers[mnr].ProcessName=NULL;
			if(What==COMPONV)
				SemGlobal->Modifiers[mnr].ComponName=strdup(SemGlobal->actcompo);
			if(SemGlobal->actEntityContext[0]!=0 && What!=COMPONV)
				SemGlobal->Modifiers[mnr].ComponName=strdup(SemGlobal->actEntityContext);
			if(SemGlobal->varlevel>0)
			{
				if(SemGlobal->actProcessContext[0]!=0)
					SemGlobal->Modifiers[mnr].ProcessName=strdup(SemGlobal->actProcessContext);
			}
			SemGlobal->ModifiersCnt.real++;
			break;
		}
	}
	SemGlobal->NamesCnt++;
}//CheckNewName


int BodyParsing(FILE *dest, char *dpath, char *archname, int level, char *valuef)
{
#if 1
	char bufor[BUFSIZE], ProcessName[NAMESIZE], componname[NAMESIZE], errmesg[BUFSIZE];
	int value, ileproc=0, ileicf=0, ilebegin=1;
	while(fgets(bufor, BUFSIZE, SemGlobal->srcf))
	{
		int NameValue;
		value=getvalue(bufor, dest);
		NameValue=value;
		if(value>=IDENTV)
		{
			char RealName[NAMESIZE];
			strcpy(ProcessName, bufor);//ewentualna nazwa procesu lub etykieta
			getname(ProcessName, RealName);
			if(!fgets(bufor, BUFSIZE, SemGlobal->srcf))
			{
				fprintf(dest, "%s", ProcessName);
				semerror(ERRUNEXEOF, NULL);
				break;
			}
			value=getvalue(bufor, dest);
			if(value==DOTV && !stricmp(RealName, "work"))
			{
				int isIdent=1;
				while(fgets(bufor, BUFSIZE, SemGlobal->srcf))
				{
					value=getvalue(bufor, dest);
					if(value==DOTV || value>=IDENTV)
					{
						if(value==DOTV)
							isIdent=0;
						else
							isIdent=1;
					}
					else
					{
						int i;
						FILE *vfile;
						char TmpLexemStr[SBSIZE], RealFunctionName[SBSIZE], RealPath[PATHSIZE], PathPart[SBSIZE];
						//Dopisac wpisywanie leksemu tymczasowego
						sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+200);
						WriteLastLexemId(TmpLexemStr);
						fprintf(dest, "%d\tidentifier:\t%s\n", SemGlobal->LastLexemId+199, TmpLexemStr);
						getname(SemGlobal->ListOfYY[SemGlobal->LexemsInListCnt-1].tokstr, RealFunctionName);
						RealPath[0]=0;
						getname(ProcessName, PathPart);
						if(!stricmp(PathPart, "work"))
							strcpy(RealPath, "library");
						else
							strcpy(RealPath, "..\\syslib");
						for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
						{
							if(!(i%2) && i<SemGlobal->LexemsInListCnt-1)
							{
								getname(SemGlobal->ListOfYY[i].tokstr, PathPart);
								strcat(RealPath, "\\");
								strcat(RealPath, PathPart);
							}
						}
						if(value==LEFTBRV)
						{
							FreeListOfYY();
							fprintf(dest, "%s", bufor);
							vfile=fopen(valuef, "at");
							fprintf(vfile, "%d\t%s\t0\t21\t0\t0\t0\t0\t%s\n", SemGlobal->LastLexemId+199, RealFunctionName, RealPath);
							fclose(vfile);
						}
						else
						{
							char line[BUFSIZE], LocalPath[PATHSIZE]; 
							strcat(RealPath, "\\");
							strcat(RealPath, PathPart);
							strcpy(LocalPath, RealPath);
							strcat(RealPath, ".val");
							FindLexemInPackage(RealPath, line, SemGlobal->ListOfYY[i-1].tokstr);
							/*Dolozyc obsluge przypadkow, kiedy lexem jest znajdowany po raz drugi*/
							if(*line)
							{
								char *ptr;
								FreeListOfYY();
								ptr=line;
								while(*ptr!='\t')
									ptr++;
								ptr++;
								while(*ptr!='\t')
									ptr++;
								fprintf(dest, "%s", bufor);
								vfile=fopen(valuef, "at");
								fprintf(vfile, "%d\t%s%s", SemGlobal->LastLexemId+199, TmpLexemStr, ptr);
								fclose(vfile);
							}
							else
							{
								sprintf(RealPath, "%s.id", LocalPath);
								FindEnumInPackage(RealPath, line, SemGlobal->ListOfYY[i-1].tokstr);
								DeleteLastChar(line);
								if(*line)
								{
									char *ptr;
									ptr=line;
									while(*ptr!='\t')
										ptr++;
									ptr++;
									fprintf(dest, "%s", bufor);
									vfile=fopen(valuef, "at");
									fprintf(vfile, "%d\t%s\tENUM\t%s\n", SemGlobal->LastLexemId+199, TmpLexemStr, ptr);
									fclose(vfile);
								}
								FreeListOfYY();
							}
							if(!(*line))
								semerror(ERRSEMVALNFIP, NULL);
						}
						break;
					}
					yylval.toknum=value;
					yylval.semval=value;
					strcpy(yylval.tokstr, bufor);
					NextYY();
				}
				continue;
			}
			if(value==COLONV)
			{
				if(!fgets(bufor, BUFSIZE, SemGlobal->srcf))
				{
					fprintf(dest, "%s", ProcessName);
					fprintf(dest, "113\tspecial_character:\t:\n");
					semerror(ERRUNEXEOF, NULL);
					break;
				}
				value=getvalue(bufor, dest);
				if(value==ASSERTV || value==ATTRIBV)
				{
					ReadToSemiC();
					if(!fgets(bufor, BUFSIZE, SemGlobal->srcf))
					{
						fprintf(dest, "%s", ProcessName);
						fprintf(dest, "113\tspecial_character:\t:\n");
						semerror(ERRUNEXEOF, NULL);
						break;
					}
					value=getvalue(bufor, dest);
				}
				if(value==BLOCKV)//blok z nazwa (nazwa bloku musi wystapic)
				{
					char blname[NAMESIZE];
					int ModifiedValue;
					getname(ProcessName, blname);
					ModifiedValue=AddToBlockList(blname);
					if(ModifiedValue)
						NameValue=ModifiedValue;
					if(ileproc==0)
						ileproc=1;
					level++;
					strcpy(SemGlobal->actroot, archname);
					if(BlockParse(dpath, level, blname)==-1)
						return -1;
					if(*blname!='\\')
					{
						fprintf(dest,
							"%d\tkeyword:\tblock\n%d\tidentifier:\t%s\n",
							BLOCKV, NameValue, blname);
					}
					else
					{
						fprintf(dest,
							"%d\tkeyword:\tblock\n%d\tidentifier:\t%s\n",
							BLOCKV, SemGlobal->LastLexemId+200, SemGlobal->LastFoundName);
						WriteLastLexemId(SemGlobal->LastFoundName);

					}
					level--;
					continue;				   
				}
				if(value==FORV || value==IFV)//generate z etykieta
				{
					if(ileproc==0)
						ileproc=1;
					level++;
					strcpy(SemGlobal->actroot, archname);
					if(NoNamedGenerateParse(dpath, level, bufor)==-1)
						return -1;
					fprintf(dest,
						"%d\tkeyword:\tgenerate\n%d\tidentifier:\t%s\n",
						GENERATEV, SemGlobal->LastLexemId+200, SemGlobal->LastFoundName);
					WriteLastLexemId(SemGlobal->LastFoundName);
					level--;
					continue;
				}
				if(value==PROCESSV)//proces z nazwa
				{
					char prname[NAMESIZE];
					int ModifiedValue;
					getname(ProcessName, prname);
					ModifiedValue=AddToProcessList(prname);
					if(ModifiedValue)
						NameValue=ModifiedValue;
					if(ileproc==0)
						ileproc=1;
					level++;
					strcpy(SemGlobal->actroot, archname);
					if(ProcessParse(dpath, level, prname)==-1)
						return -1;
					if(*prname!='\\')
						fprintf(dest,
							"%d\tkeyword:\tprocess\n%d\tidentifier:\t%s\n",
							PROCESSV, NameValue, prname);
					else
					{
						fprintf(dest,
							"%d\tkeyword:\tprocess\n%d\tidentifier:\t%s\n",
							PROCESSV, SemGlobal->LastLexemId+200, SemGlobal->LastFoundName);
						WriteLastLexemId(SemGlobal->LastFoundName);
					}
					level--;
					continue;				   
				}
				else//prawdopodobnie nazwa componentu lub zwykla etykieta
				{
					FILE *vfile;
					int componvalue=0;
					fprintf(dest, "%s", ProcessName);
					fprintf(dest, "113\tspecial_character:\t:\n");
					value=getvalue(bufor, dest);
					if(value>200 || value==COMPONV)
					{
						if(value>200)
							componvalue=value;
						if(value==COMPONV)
						{
							if(!fgets(bufor, BUFSIZE, SemGlobal->srcf))
							{
								fprintf(dest, "%d", value);
								fprintf(dest, "\tidentifier:\t:%s\n", componname);
								semerror(ERRUNEXEOF, NULL);
								break;
							}
							value=getvalue(bufor, NULL);
							fprintf(dest, "17\tkeyword:\tcomponent\n");
						}
						AliasCheckAndReplace(bufor);//W przypadku kiedy zostanie zmodyfikowana nazwa jednostki
						//nalezy dolozyc old i new wartosci
						value=getvalue(bufor, NULL);
						getname(bufor, componname);
						if(!fgets(bufor, BUFSIZE, SemGlobal->srcf))
						{
							fprintf(dest, "%d", value);
							fprintf(dest, "\tidentifier:\t:%s\n", componname);
							semerror(ERRUNEXEOF, NULL);
							break;
						}
						fprintf(dest, "%d", value);
						fprintf(dest, "\tidentifier:\t%s\n", componname);
						value=getvalue(bufor, dest);
						if(value!=PORTV && value!=GENERICV)
						{
							fprintf(dest, "%s", bufor);
							continue;
						}
						else
							fprintf(dest, "%s", bufor);
						if(!fgets(bufor, BUFSIZE, SemGlobal->srcf))
						{
							semerror(ERRUNEXEOF, NULL);
							break;
						}
						value=getvalue(bufor, dest);
						if(value!=MAPV)
						{
							
							sprintf(errmesg, ": %s", bufor);
							semerror(ERRUNSCONSTRUCT, errmesg);
						}
						else
							fprintf(dest, "%s", bufor);
						CopyPortMap(dest, componname);
						NewComponentName(componname);
						if(componvalue)
						{
							vfile=fopen(valuef, "at");
							fprintf(vfile, "%d\t%s\t0\t6\t0\t0\t0\t0\n", componvalue, componname);
							fclose(vfile);
						}
						continue;
					}
				}
			}
			else
			{	
				AliasCheckAndReplace(ProcessName);
				fprintf(dest, "%s", ProcessName);
				fprintf(dest, "%s", bufor);
				continue;
			}
		}
		if(value==PROCESSV)//process bez nazwy
		{
			if(ileproc==0)
				ileproc=1;
			level++;
			strcpy(SemGlobal->actroot, archname);
			if(NoNamedProcessParse(dpath, level)==-1)
				return -1;
			fprintf(dest,
				"%d\tkeyword:\tprocess\n%d\tidentifier:\t%s\n",
				PROCESSV, SemGlobal->LastLexemId+200, SemGlobal->LastFoundName);
			WriteLastLexemId(SemGlobal->LastFoundName);
			level--;
			continue;
		}
		if(value==FORV || value==IFV)//generate bez nazwy
		{
			if(ileproc==0)
				ileproc=1;
			level++;
			strcpy(SemGlobal->actroot, archname);
			if(NoNamedGenerateParse(dpath, level, bufor)==-1)
				return -1;
			fprintf(dest,
				"%d\tkeyword:\tgenerate\n%d\tidentifier:\t%s\n",
				GENERATEV, SemGlobal->LastLexemId+200, SemGlobal->LastFoundName);
			WriteLastLexemId(SemGlobal->LastFoundName);
			level--;
			continue;
		}
		if(value==ASSERTV || value==ATTRIBV)
		{
			ReadToSemiC();
			continue;
		}
		if(value==ENDV)
		{
			if(!ileicf)
				ilebegin--;
			else
			{
				fprintf(dest, "%s", bufor);
				fgets(bufor, BUFSIZE, SemGlobal->srcf);
				value=getvalue(bufor, dest);
				if(value==IFV || value==CASEV || value==FORV || value==LOOPV || value==SEMICV || value==GENERATEV)
					ileicf--;
				fprintf(dest, "%s", bufor);
				continue;
			}
		}
		if(ilebegin==0)
			break;
		if(value==BEGINV)
			ilebegin++;
		if(value==IFV || value==CASEV || value==FORV || value==LOOPV)
			ileicf++;
		fprintf(dest, "%s", bufor);
	}
	fprintf(dest, "%s", bufor);
	FreeFullListForAlias();
#endif
	return 0;
}