#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
/*funkcje do konwersji roznych liczb na postac bitowa - wersja finalna*/

/* konwersja liczb (nie bitstringow) */
char* octtobin(const char *oct)
{
	static char tbin[33]="00000000000000000000000000000000";
	/*tablica konwersji z cyfry osemkowej na 3 cyfry binarne*/
	static char ktab[8][4]=
	{
		"000", "001", "010", "011", "100", "101", "110", "111"
	};
	char *bin, c, btab[4];
	unsigned len;
	int j,l, k;//k-dlugosc lancucha binarnego
	strcpy(tbin,"00000000000000000000000000000000");
	len=strlen(oct);
	k=len*3;
	bin=(char*)malloc(sizeof(char)*(k+2));
	if(bin==NULL)
		return NULL;
	
	bin[k]=0;
	for( j=len-1; j>=0 ; j--)
	{
		c=oct[j];
		if(c>='0' && c<'8')
		{
			c-='0';
			strcpy(btab, ktab[c]);
			k--;bin[k]=btab[2];
			k--;bin[k]=btab[1];
			k--;bin[k]=btab[0];
		}
		else
		{
			if(c!='_')
				return NULL;
		}
	}
	k=len*3;
	for(l=0 ; l<k ; l++)//zwracac bedziemy tylko cyfry znaczace
		if(bin[l]=='1')
			break;
		if(k-l>31)//sprawdzenie konieczne w przypadku zbyt dlugich danych wejsciowych
			return NULL;
		sprintf(tbin+32-k+l, "%s", bin+l);
		free(bin);
		return tbin;
}

/*konwersja bitsringow osemkowych*/
char* bitocttobin(const char *oct)
{
	static char tbin[33];
	/*tablica konwersji z cyfry osemkowej na 3 cyfry binarne*/
	static char ktab[8][4]=
	{
		"000", "001", "010", "011", "100", "101", "110", "111"
	};
	char *bin, c, btab[4];
	unsigned len, k;//k-dlugosc lancucha binarnego
	int j;
	len=strlen(oct);
	k=len*3;
	bin=(char*)malloc(sizeof(char)*(k+1));
	if(bin==NULL)
		return NULL;
	
	
	bin[k]=0;
	for( j=len-1; j>=0 ; j--)
	{
		c=oct[j];
		if(c>='0' && c<'8')
		{
			c-='0';
			strcpy(btab, ktab[c]);
			k--;bin[k]=btab[2];
			k--;bin[k]=btab[1];
			k--;bin[k]=btab[0];
		}
		else
		{
			if(c!='_')
				return NULL;
		}
	}
	sprintf(tbin, "%s",  bin+k);
	free(bin);
	return tbin;
}


/*konwersja normalnych liczb szesnastkowych (nie bitstringow) */
char* hextobin(const char *hex)
{
	static char tbin[33]="00000000000000000000000000000000";
	/*tablica konwersji z cyfry szesnastkowej na 4 cyfry binarne*/
	static char ktab[16][5]=
	{
		"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111",
			"1000", "1001", "1010", "1011",	"1100", "1101", "1110", "1111"
	};
	char *bin, c, btab[5];
	unsigned len;
	int j, l, k;//k-dlugosc lancucha binarnego
	strcpy(tbin,"00000000000000000000000000000000");
	len=strlen(hex);
	k=len<<2;
	bin=(char*)malloc(sizeof(char)*(k+1));
	if(bin==NULL)
		return NULL;
	
	bin[k]=0;
	for( j=len-1; j>=0  ; j--)
	{
		c=hex[j];
		if(isxdigit(c))
		{
			if(isdigit(c))
				c-='0';
			else
				c=toupper(c)-55;//c-'A'+10
			strcpy(btab, ktab[c]);
			k--;bin[k]=btab[3];
			k--;bin[k]=btab[2];
			k--;bin[k]=btab[1];
			k--;bin[k]=btab[0];
		}
		else
		{
			if(c!='_')
				return NULL;
		}
	}
	k=len<<2;
	for(l=0 ; l<k ; l++)//zwracac bedziemy tylko cyfry znaczace
		if(bin[l]=='1')
			break;
		if(k-l>31)//sprawdzenie konieczne w przypadku zbyt dlugich danych wejsciowych
			return NULL;
		sprintf(tbin+32-k+l, "%s", bin+l);
		free(bin);
		return tbin;
}

/*konwersja szesnastkowych bitstringow*/
char* bithextobin(const char *hex)
{
	static char tbin[33];
	/*tablica konwersji z cyfry szesnastkowej na 4 cyfry binarne*/
	static char ktab[16][5]=
	{
		"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111",
			"1000", "1001", "1010", "1011",	"1100", "1101", "1110", "1111"
	};
	char *bin, c, btab[5];
	unsigned len, k;//k-dlugosc lancucha binarnego
	int j;
	
	len=strlen(hex);
	k=len<<2;
	bin=(char*)malloc(sizeof(char)*(k+1));
	if(bin==NULL)
		return NULL;
	
	bin[k]=0;
	for( j=len-1; j>=0 ; j--)
	{
		c=hex[j];
		if(isxdigit(c))
		{
			if(isdigit(c))
				c-='0';
			else
				c=toupper(c)-55;//c-'A'+10
			strcpy(btab, ktab[c]);
			k--;bin[k]=btab[3];
			k--;bin[k]=btab[2];
			k--;bin[k]=btab[1];
			k--;bin[k]=btab[0];
		}
		else
		{
			if(c!='_')
				return NULL;
		}
	}
	sprintf(tbin, "%s", bin+k);
	free(bin);
	return tbin;
}

/*Zwrocenie bitsringu z powycinanymi znakami '_'*/
char* bitbintobin(const char *bits)
{
	static char tbin[33];
	char *bin, c;
	int j;
	unsigned k;
	k=strlen(bits);
	bin=(char*)malloc(sizeof(char)*(k+1));
	if(bin==NULL)
		return NULL;
	bin[k]=0;
	for( j=k-1; j>=0 ; j--)
	{
		c=bits[j];
		if(c=='0' || c=='1')
		{
			k--;bin[k]=c;
		}
		else
		{
			if(c!='_' && j>0)
				return NULL;
		}
	}
	sprintf(tbin, "%s", bin+k);
	free(bin);
	return tbin;
}

char* anytobin(const char *any, unsigned base)
{
	static char tbin[33]="00000000000000000000000000000000";
	/*tablica konwersji z liczby od 1 do 16 na 4 cyfry binarne*/
	static char ktab[16][5]=
	{
		"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111",
			"1000", "1001", "1010", "1011",	"1100", "1101", "1110", "1111"
	};//tablica do znajdowania mnoznika i mnozonych ciagow
	unsigned char c;
	char *bin, btab[5];
	char *mult, muls[5];//mult, muls-lancuchy 0 i 1 uzywany do mnozenia
	char *sh, *shsum;
	unsigned len;
	int j, l, m, s, r, w, rest, shlen, k;//k-dlugosc lancucha binarnego
	strcpy(tbin,"00000000000000000000000000000000");
	if(base<2 || base>16)
		return NULL;
	if(base==16)
		return hextobin(any);
	if(base==8)
		return octtobin(any);
	len=strlen(any);
	k=len<<2;//przyjmuje sie dlugosc lancucha jak dla liczby hex
	bin=(char*)malloc(sizeof(char)*(k+10));
	sh=(char*)malloc(sizeof(char)*(k+5));
  shsum=(char*)malloc(sizeof(char)*(k+9));
	mult=(char*)malloc(sizeof(char)*(k+5));
	if(bin==NULL || mult==NULL)
		return NULL;
	memset(bin, '0', k+5);
	bin[k+5]=0;
	strcpy(mult, ktab[1]);
	strcpy(muls, ktab[base]);
	memset(shsum, '0', k+4);
	shsum[k+4]=0;
	//glowna petla przechodzaca prze wszystkie znaki konwertowanego lancucha
	for( j=len-1 ; j>=0 /*minus*/ ; j--)
	{
		c=any[j];
		if(isxdigit(c))
		{
			if(isdigit(c))
				c-='0';
			else
				c=toupper(c)-55;//c-'A'+10
			if(c>=base)
				return NULL;//cyfra spoza przedzialu
			//mnozona aktualnie cyfra zapisana binarnie
			strcpy(btab, ktab[c]);
			memset(shsum, '0', k+4);
      shsum[k+4]=0;
			//skladamy 4 mnozenia np: x*15=x*8+x*4+x*2+x*1
			for(l=3 ; l>=0 ; l--)
			{
				if(btab[l]=='1')
				{
					strcpy(sh, mult);
					shlen=strlen(sh);
					for(m=0 ; m<3-l ; m++)
						sh[shlen+m]='0';
					sh[shlen+m]=0;
					rest=0;
					for(s=strlen(sh)-1, r=strlen(shsum)-1 ; s>=0 ; s--, r--)
					{
						w=rest+sh[s]-'0'+shsum[r]-'0';
						if(w>1)
						{
							rest=1;
							w-=2;
						}
						else
							rest=0;
						shsum[r]=w+'0';
					}
					shsum[r]=rest+'0';
				}
			}
			rest=0;
			for(s=strlen(shsum)-1, r=strlen(bin)-1 ; s>=0 ; s--, r--)
			{
				w=rest+shsum[s]-'0'+bin[r]-'0';
				if(w>1)
				{
					rest=1;
					w-=2;
				}
				else
					rest=0;
				bin[r]=w+'0';
			}
			bin[r]=rest+'0';
			memset(shsum, '0', k+4);
      shsum[k+4]=0;
			//skladamy 4 mnozenia np: x*15=x*8+x*4+x*2+x*1
			for(l=3 ; l>=0 ; l--)
			{
				if(muls[l]=='1')
				{
					strcpy(sh, mult);
					shlen=strlen(sh);
					for(m=0 ; m<3-l ; m++)
						sh[shlen+m]='0';
					sh[shlen+m]=0;
					rest=0;
					for(s=strlen(sh)-1, r=strlen(shsum)-1 ; s>=0 ; s--, r--)
					{
						w=rest+sh[s]-'0'+shsum[r]-'0';
						if(w>1)
						{
							rest=1;
							w-=2;
						}
						else
							rest=0;
						shsum[r]=w+'0';
					}
					shsum[r]=rest+'0';
				}
			}
			for(l=0 ; l<k+4 ; l+=4)//kopiujemy tylko cyfry znaczace, wyrownanie do 4
			{
				if(   shsum[l]=='1'   || shsum[l+1]=='1' ||
					shsum[l+2]=='1' || shsum[l+3]=='1')
					break;
			}
			strcpy(mult, shsum+l);
		}
		else
		{
			if(c!='_')
				return NULL;
		}
	}
	free(sh);
	free(shsum);
	free(mult);
	k=(len<<2)+5;
	for(l=0 ; l<k ; l++)//zwracac bedziemy tylko cyfry znaczace
		if(bin[l]=='1')
			break;
		if(k-l>31)
			return NULL;
		sprintf(tbin+32-k+l, "%s", bin+l);
		free(bin);
		return tbin;
}
