#if 0
#define NDEBUG
#endif
#include <assert.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifndef _MSC_VER
  #include <unistd.h>
#else
  #include <direct.h>
#endif
#include <string.h>
//#include <sys/stat.h>
#include "vhdl_tab.h"
#include "stack.h"
#include "semerr.h"
#include "semval.h"
#include "tstst.h"
#include "tmpvar.h"

#if 0
#define NO_GENERATION
#endif

extern YYSTYPE yylval;
extern struct PBGLOBAL *SemGlobal;
extern DECL_STATUS decl_status;

void NextYY(void)
{
	YYSTYPE *t;
	if(SemGlobal->ListOfYY==NULL)
	{
		SemGlobal->LexemsInListCnt=1;
		SemGlobal->ListOfYY=(YYSTYPE*)malloc(sizeof(YYSTYPE));
		t=SemGlobal->ListOfYY;
		t->toknum=yylval.toknum;
		t->semval=yylval.semval;
		strcpy(t->tokstr,yylval.tokstr);
	}
	else
	{
		SemGlobal->ListOfYY=(YYSTYPE*)realloc((YYSTYPE*)SemGlobal->ListOfYY, (SemGlobal->LexemsInListCnt+1)*sizeof(YYSTYPE));
		t=SemGlobal->ListOfYY+SemGlobal->LexemsInListCnt;
		t->toknum=yylval.toknum;
		t->semval=yylval.semval;
		strcpy(t->tokstr, yylval.tokstr);
		SemGlobal->LexemsInListCnt++;
	}
}//NextYY


void FreeListOfYY(void)
{
	if(SemGlobal->LexemsInListCnt)
	{
		free(SemGlobal->ListOfYY);
		SemGlobal->ListOfYY=NULL;
		SemGlobal->LexemsInListCnt=0;
	}
}//FreeListOfYY


void ParseExpression(int *val)
{
		if(yylval.semval==tok_Minus)
		{
			NextYY();
			yylex();
			if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
				*val-=atoi(yylval.tokstr);
		}
		if(yylval.semval==tok_Plus)
		{
			NextYY();
			yylex();
			if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
				*val+=atoi(yylval.tokstr);
		}
		if(yylval.semval==tok_Slash)
		{
			NextYY();
			yylex();
			if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
				*val/=atoi(yylval.tokstr);
		}
		if(yylval.semval==tok_Star)
		{
			NextYY();
			yylex();
			if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
				*val*=atoi(yylval.tokstr);
		}
		if(yylval.semval==tok_DoubleStar)
		{
			NextYY();
			yylex();
			if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
				*val=(int)pow(*val, atoi(yylval.tokstr));
		}
}//ParseExpression


int GetSliceOfType(char *typestr)
{
	int Arg1Legal, Arg2Legal, isSemicolonRead, isInArray;
	int toknum, left=0, left_sign, right, right_sign, to_or_downto;
	char IntOrArray[6];
	
	if(yylval.semval==tok_LeftParen)
	{
		isInArray=1;
		strcpy(IntOrArray, "ARRAY");
	}
	else
	{
		isInArray=0;
		strcpy(IntOrArray, "INT");
	}
	SemGlobal->ListOfYY=NULL;
	/* get left limit */
	isSemicolonRead=0;
	if( yylex()==tok_Minus)
	{
		NextYY();
		left_sign=-1;
		yylex();
	}
	else
		left_sign=1;
	NextYY();
	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg1Legal=1;
	else
		Arg1Legal=0;
	sscanf(yylval.tokstr, "%d", &left);
	left*=left_sign;
	/* skip tok_TO, tok_DOWNTO */
	while(yylex()!=tok_TO)
	{
		if(yylval.semval==tok_DOWNTO)
			break;
		if(yylval.semval==tok_Semicolon)
			return 1;
		if(!(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit))
			Arg1Legal=0;
		NextYY();
	}
	NextYY();
	to_or_downto=yylval.semval;
	/* get right limit */
	if( yylex()==tok_Minus)
	{
		NextYY();
		right_sign=-1;
		yylex();
	}
	else
		right_sign=1;
	NextYY();
	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg2Legal=1;
	else
		Arg2Legal=0;
	sscanf(yylval.tokstr, "%d", &right);
	right*=right_sign;
	/* check it with base TYPE */
	
	/* Very Important */
	sscanf(typestr, "%d", &toknum);
	if(toknum==STRINGLV)
	{
		if(min(right,left)<1)
		{
			semerror(ERRBADARRAYBOUNDS, NULL);
		}
	}
	if(Arg1Legal && Arg2Legal)
	{
		int BitsCnt;
		if( to_or_downto==tok_TO)
		{
			if(isInArray)
				BitsCnt=abs(right-left)+1;
			else
				BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
			sprintf( typestr,"%d\t%d\t%d\t%d\t%d\t%d\t%d",
				toknum, decl_status.Class, decl_status.mode,
				BitsCnt,
				min(left,right), max(left,right), toknum
				); 
		}
		else
		{
			if(isInArray)
				BitsCnt=abs(left-right)+1;
			else
				BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
			sprintf( typestr,"%d\t%d\t%d\t%d\t%d\t%d\t%d",
				toknum, decl_status.Class, decl_status.mode,
				BitsCnt,
				max(left,right), min(left,right), toknum
				);
		}
	}
	else
	{
		while(yylex()!=tok_RightParen)
		{
			if(yylval.semval==tok_Semicolon)
			{
				isSemicolonRead=1;
				break;
			}
			NextYY();
		}
	}
	if(!isSemicolonRead)
		ReadToIsOrSemiC();
	if(SemGlobal->isInValFile)
	{
		int i;
		i=strlen(typestr);
		while(i--)
		{
			if(typestr[i]==' ' || typestr[i]=='\t')
			{
				typestr[i]=0;
				break;
			}
		}
		//SemGlobal->isInValFile=0;
	}
	if(Arg1Legal && Arg2Legal)
	{
		FreeListOfYY();
		return 0;
	}
	else 
		return 1;
}//GetSliceOfType


int GetRangeForArray(char *typestr, int rangetype)
{
	int Arg1Legal, Arg2Legal, isSemicolonRead;
	int toknum, left=0, left_sign, right, right_sign, to_or_downto;
	
	SemGlobal->ListOfYY=NULL;
	/* get left limit */
	isSemicolonRead=0;
	if( yylval.toknum==tok_Minus)
	{
		NextYY();
		left_sign=-1;
		yylex();
	}
	else
		left_sign=1;
	NextYY();
	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg1Legal=1;
	else
		Arg1Legal=0;
	sscanf(yylval.tokstr, "%d", &left);
	left*=left_sign;
	/* skip tok_TO, tok_DOWNTO */
	while(yylex()!=tok_TO)
	{
		if(yylval.semval==tok_DOWNTO)
			break;
		if(yylval.semval==tok_Semicolon)
			return 1;
		NextYY();
	}
	NextYY();
	to_or_downto=yylval.semval;
	/* get right limit */
	if( yylex()==tok_Minus)
	{
		NextYY();
		right_sign=-1;
		yylex();
	}
	else
		right_sign=1;
	NextYY();
	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg2Legal=1;
	else
		Arg2Legal=0;
	sscanf(yylval.tokstr, "%d", &right);
	right*=right_sign;
	/* check it with base TYPE */
	
	/* Very Important */
	sscanf(typestr, "%d", &toknum);
	if(Arg1Legal && Arg2Legal)
	{
		int BitsCnt;
		if( to_or_downto == tok_TO)
		{
			if(rangetype==1)
			{
				if(left<0)
					semerror(ERRBADARRAYBOUNDS, NULL);
			}
			if(rangetype==2)
			{
				if(left<1)
					semerror(ERRBADARRAYBOUNDS, NULL);
			}
			if( left < right)
				BitsCnt=abs(right-left)+1;
			else
				BitsCnt=0;
			sprintf(typestr, "%d\t%d\t%d\t", BitsCnt, min(left,right), max(left,right)); 
		}
		else
		{
			if(rangetype==1)
			{
				if(right<0)
					semerror(ERRBADARRAYBOUNDS, NULL);
			}
			if(rangetype==2)
			{
				if(right<1)
					semerror(ERRBADARRAYBOUNDS, NULL);
			}
			if( left > right)
				BitsCnt=abs(left-right)+1;
			else
				BitsCnt=0;
			sprintf(typestr, "%d\t%d\t%d\t", BitsCnt, min(left,right), max(left,right)); 
		}
		while(yylex()!=tok_RightParen);
	}
	else
	{
		while(yylex()!=tok_RightParen)
			NextYY();
	}
	if(SemGlobal->isInValFile)
	{
		int i;
		i=strlen(typestr);
		while(i--)
		{
			if(typestr[i]==' ' || typestr[i]=='\t')
			{
				typestr[i]=0;
				break;
			}
		}
		SemGlobal->isInValFile=0;
	}
	if(Arg1Legal && Arg2Legal)
	{
		FreeListOfYY();
		return 0;
	}
	else 
		return 1;
}//GetSliceOfType



int ParentTypeFromLine(char *tokstr, int *lvalue)
{
	int ColCnt=0;
	char *t, valstr[1024];
	t=tokstr;
	while(ColCnt<6)
	{
		while(*t!='\n' && *t!='\t' && *t!=' ' && *t!=0)
			t++;
		if(*t=='\n' || *t==0)
			return 0;
		ColCnt++;
		t++;
	}
	sscanf(t, "%s", valstr);
	*lvalue=atoi(valstr);
	return 1;
}//ParentTypeFromLine


int ValueFromLine(char *tokstr, int *lvalue)
{
	int ColCnt=0;
	char *t, valstr[1024];
	t=tokstr;
	while(ColCnt<8)
	{
		while(*t!='\n' && *t!='\t' && *t!=' ' && *t!=0)
			t++;
		if(*t=='\n' || *t==0)
			return 0;
		ColCnt++;
		t++;
	}
	sscanf(t, "%s", valstr);
	*lvalue=BitStringToIntValue(valstr);
	return 1;
}//ValueFromLine


int GetSliceOfTypeForSubtype(char *typestr)
{
	int Arg1Legal, Arg2Legal, isSemicolonRead, isInArray;
	int toknum, left, left_sign, right, right_sign, to_or_downto, sv;
	char IntOrArray[6];

	if(yylval.semval==tok_LeftParen)
	{
		isInArray=1;
		strcpy(IntOrArray, "ARRAY");
	}
	else
	{
		isInArray=0;
		strcpy(IntOrArray, "INT");
	}
	SemGlobal->ListOfYY=NULL;
	/* get left limit */
	isSemicolonRead=0;
	if( yylex()==tok_Minus)
	{
		NextYY();
		left_sign=-1;
		yylex();
	}
	else
		left_sign=1;
	NextYY();
	sv=yylval.semval;
	if(sv==tok_AbstractLit || sv==tok_StringLit || sv==tok_BitStringLit)
		Arg1Legal=1;
	else
	{
		Arg1Legal=0;
		strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
		if(FindLexemInformation(yylval.toknum, yylval.tokstr)==1)
		{
			int ltoknum, ltypein, lvalue;
			char IsLenum[256];
			//check if found lexem is in enum type
			sscanf(yylval.tokstr, "%d\t%d\t%d\t%s", &ltoknum, &ltypein, &lvalue, IsLenum);
			if(!stricmp(IsLenum, "LENUM"))
			{
				sprintf(yylval.tokstr, "%d", lvalue);
				Arg1Legal=1;
			}
			if(SemGlobal->isInPackage)
			{
				if(ValueFromLine(yylval.tokstr, &lvalue))
				{
					sprintf(yylval.tokstr, "%d", lvalue);
					Arg1Legal=1;
				}
			}
		}
	}
	sscanf(yylval.tokstr, "%d", &left);
	left*=left_sign;
	/* skip tok_TO, tok_DOWNTO */
	while(yylex()!=tok_TO)
	{
		if(yylval.semval==tok_DOWNTO)
			break;
		if(yylval.semval==tok_Semicolon)
			return 1;
		Arg1Legal=0;
		NextYY();
	}
	NextYY();
	to_or_downto=yylval.semval;
	/* get right limit */
	if( yylex()==tok_Minus)
	{
		NextYY();
		right_sign=-1;
		yylex();
	}
	else
		right_sign=1;
	NextYY();
	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg2Legal=1;
	else
	{
		Arg2Legal=0;
		strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
		if(FindLexemInformation(yylval.toknum, yylval.tokstr)==1)
		{
			int ltoknum, ltypein, lvalue;
			char IsLenum[256];
			//check if found lexem is in enum type
			sscanf(yylval.tokstr, "%d\t%d\t%d\t%s", &ltoknum, &ltypein, &lvalue, IsLenum);
			if(!stricmp(IsLenum, "LENUM"))
			{
				sprintf(yylval.tokstr, "%d", lvalue);
				Arg2Legal=1;
			}
			if(SemGlobal->isInPackage)
			{
				if(ValueFromLine(yylval.tokstr, &lvalue))
				{
					sprintf(yylval.tokstr, "%d", lvalue);
					Arg2Legal=1;
				}
			}
		}
	}
	sscanf(yylval.tokstr, "%d", &right);
	right*=right_sign;
	/* check it with base TYPE */
	
	/* Very Important */
	sscanf(typestr, "%d", &toknum);
	if(Arg1Legal && Arg2Legal)
	{
		int BitsCnt;
		if( to_or_downto==tok_TO)
		{
			if(isInArray)
				BitsCnt=right-left+1;
			else
				BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
			sprintf( typestr,"%s\t%d\t%d\t%d\t%d",
				IntOrArray,
				BitsCnt,
				min(left,right), max(left,right), toknum
				); 
		}
		else
		{
			if(isInArray)
				BitsCnt=left-right+1;
			else
				BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
			sprintf( typestr,"%s\t%d\t%d\t%d\t%d",
				IntOrArray,
				BitsCnt,
				max(left,right), min(left,right), toknum
				);
		}
	}
	else
	{
		while(yylex()!=tok_RightParen)
		{
			if(yylval.semval==tok_Semicolon)
			{
				isSemicolonRead=1;
				break;
			}
			NextYY();
		}
	}
	if(!isSemicolonRead)
		ReadToSemiC();

	if(Arg1Legal && Arg2Legal)
	{
		FreeListOfYY();
		return 0;
	}
	else 
		return 1;
}//GetSliceOfTypeForSubtype



int GetSliceOfTypeForArray(char *typestr, int *tmpToDownto)
{
	int Arg1Legal, Arg2Legal, isInArray=1, ParenCnt;
	int toknum, left, left_sign, right, right_sign, to_or_downto;

	SemGlobal->ListOfYY=NULL;
	ParenCnt=0;
	/* get left limit */
	if(yylval.semval==tok_RANGE)
		yylex();
	if(yylval.semval==tok_LeftParen)
	{
		ParenCnt++;
		while(yylval.semval==tok_LeftParen)
		{
			NextYY();
			yylex();
			if(yylval.semval==tok_LeftParen)
				ParenCnt++;
		}
	}
	NextYY();
	if( yylval.semval==tok_Minus)
	{
		NextYY();
		left_sign=-1;
		yylex();
	}
	else
		left_sign=1;
	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg1Legal=1;
	else
	{
		Arg1Legal=0;
		strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
		if(FindLexemInformation(yylval.toknum, yylval.tokstr)==1)
		{
			int ltoknum, ltypein, lvalue;
			char IsLenum[256];
			//check if found lexem is in enum type
			sscanf(yylval.tokstr, "%d\t%d\t%d\t%s", &ltoknum, &ltypein, &lvalue, IsLenum);
			if(!stricmp(IsLenum, "LENUM"))
			{
				sprintf(yylval.tokstr, "%d", lvalue);
				Arg1Legal=1;
			}
			if(ValueFromLine(yylval.tokstr, &lvalue))
			{
				sprintf(yylval.tokstr, "%d", lvalue);
				Arg1Legal=1;
			}
		}
	}
	sscanf(yylval.tokstr, "%d", &left);
	left*=left_sign;
	/* skip tok_TO, tok_DOWNTO */
	while(yylex()!=tok_TO)
	{
		if(yylval.semval==tok_DOWNTO)
			break;
		if(yylval.semval==tok_RightParen)
		{
			if(ParenCnt>1)
				ParenCnt--;
			else
				return 1;
		}
		if(yylval.semval==tok_Semicolon)
			return 1;
		if(yylval.semval==tok_Minus)
		{
			NextYY();
			yylex();
			if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
				left=left-atoi(yylval.tokstr);
			NextYY();
			continue;
		}
		if(yylval.semval==tok_Plus)
		{
			NextYY();
			yylex();
			if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
				left=left+atoi(yylval.tokstr);
			NextYY();
			continue;
		}
		NextYY();
	}
	NextYY();
	to_or_downto=yylval.semval;

	/* get right limit */
	yylex();
	if(yylval.semval==tok_LeftParen)
	{
		ParenCnt++;
		while(yylval.semval==tok_LeftParen)
		{
			NextYY();
			yylex();
			if(yylval.semval==tok_LeftParen)
				ParenCnt++;
		}
	}
	if( yylval.semval==tok_Minus)
	{
		NextYY();
		right_sign=-1;
		yylex();
	}
	else
		right_sign=1;
	NextYY();
	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg2Legal=1;
	else
	{
		Arg2Legal=0;
		strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
		if(FindLexemInformation(yylval.toknum, yylval.tokstr)==1)
		{
			int ltoknum, ltypein, lvalue;
			char IsLenum[256];
			//check if found lexem is in enum type
			sscanf(yylval.tokstr, "%d\t%d\t%d\t%s", &ltoknum, &ltypein, &lvalue, IsLenum);
			if(!stricmp(IsLenum, "LENUM"))
			{
				sprintf(yylval.tokstr, "%d", lvalue);
				Arg2Legal=1;
			}
			if(ValueFromLine(yylval.tokstr, &lvalue))
			{
				sprintf(yylval.tokstr, "%d", lvalue);
				Arg2Legal=1;
			}

		}
	}
	sscanf(yylval.tokstr, "%d", &right);
	right*=right_sign;


	yylex();
	while(ParenCnt>0)
	{
		if(yylval.semval==tok_RightParen)
		{
			ParenCnt--;
			while(ParenCnt>0 && yylval.semval==tok_RightParen)
			{
				NextYY();
				yylex();
				if(yylval.semval==tok_RightParen)
					ParenCnt--;
			}
			continue;
		}
		if(yylval.semval==tok_LeftParen)
		{
			ParenCnt++;
			while(yylval.semval==tok_LeftParen)
			{
				NextYY();
				yylex();
				if(yylval.semval==tok_LeftParen)
					ParenCnt++;
			}
			continue;
		}
		ParseExpression(&right);
		Arg2Legal=0;
		NextYY();
		yylex();
	}
	NextYY();





	
	/* check it with base TYPE */
	
	/* Very Important */
	sscanf(typestr, "%d", &toknum);
	if(Arg1Legal && Arg2Legal)
	{
		int BitsCnt;
		if( to_or_downto==tok_TO)
		{
			if(isInArray)
				BitsCnt=right-left+1;
			else
				BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
			sprintf( typestr,"%s\t%d\t%d\t%d\t",
				"ARRAY",
				BitsCnt,
				min(left,right), max(left,right) 
				); 
		}
		else
		{
			if(isInArray)
				BitsCnt=left-right+1;
			else
				BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
			sprintf( typestr,"%s\t%d\t%d\t%d\t",
				"ARRAY",
				BitsCnt,
				max(left,right), min(left,right)
				);
		}
	}
	else
	{
		if(yylval.semval!=tok_RightParen && yylval.semval!=tok_Semicolon)
		{
			while(yylex())
			{
				if(yylval.semval==tok_RightParen)
					break;
				NextYY();
			}
		}
	}
	if(yylval.semval!=tok_RightParen && yylval.semval!=tok_Semicolon)
	{
		while(yylex())
		{
			if(yylval.semval==tok_RightParen)
				break;
		}
	}
	*tmpToDownto=to_or_downto;
	if(Arg1Legal && Arg2Legal)
	{
		FreeListOfYY();
		return 0;
	}
	else 
		return 1;
}//GetSliceOfTypeForArray


int GetSliceOfTypeForEntity(char *typestr, int What)
{
	int Arg1Legal, Arg2Legal, isSemicolonRead, isInArray, isRight, isLeft;
	int toknum, left, left_sign, right, right_sign, to_or_downto;
	int ParenCnt=0, isComputedByGeneric=0;
	if(yylval.semval==tok_LeftParen)
	{
		isInArray=1;
		ParenCnt++;
	}
	else
		isInArray=0;
	isRight=0;isLeft=0;
	SemGlobal->ListOfYY=NULL;
	/* get left limit */
	isSemicolonRead=0;
	yylex();
	if( yylval.semval==tok_Minus)
	{
		NextYY();
		left_sign=-1;
		yylex();
	}
	else
		left_sign=1;
	NextYY();
	if((yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit))
		Arg1Legal=1;
	else
	{
		int i, Legal=0;
		/* Lets check generics */
		if(What!=COMPONV)
		{
			for(i=0 ; i<SemGlobal->GenericCnt ; i++)
			{
				if(yylval.toknum==SemGlobal->ListOfGenerics[i].LexemId)
				{
					int TypeOf=SemGlobal->ListOfGenerics[i].TypeOf;
					if(TypeOf==INTEGERLV || TypeOf==POSITIVELV || TypeOf==NATURALLV || TypeOf==BITLV || TypeOf==STDULOGICLV || TypeOf==STDLOGICLV)
					{
						Legal=1;
						left=SemGlobal->ListOfGenerics[i].value;
						isLeft=1;
					}
					else
					{
						char typestr[BUFSIZE];
						int BaseType;
						strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
						FindTypeString(TypeOf, typestr, typestr);
						ParentTypeFromLine(typestr, &BaseType);
						switch(BaseType)
						{
						case INTEGERLV:
						case POSITIVELV:
						case NATURALLV:
						case BITLV:
						case STDULOGICLV:
						case STDLOGICLV:
						case CHARLV:
							Legal=1;
							left=SemGlobal->ListOfGenerics[i].value;
							isLeft=1;
							break;
						default:
							semerror(ERRUNSGENERIC, NULL);
						}
					}
					isComputedByGeneric=1;
				}
			}
		}
		Arg1Legal=Legal;
	}
	if(!isLeft)
		sscanf(yylval.tokstr, "%d", &left);
	left*=left_sign;
	/* skip tok_TO, tok_DOWNTO */
	while(yylex()!=tok_TO)
	{
		ParseExpression(&left);
		if(yylval.semval==tok_DOWNTO)
			break;
		if(yylval.semval==tok_Semicolon)
			return 1;
		NextYY();
	}
	NextYY();
	to_or_downto=yylval.semval;
	/* get right limit */
	if( yylex()==tok_Minus)
	{
		NextYY();
		right_sign=-1;
		yylex();
	}
	else
		right_sign=1;
	NextYY();

	if(yylval.semval>=tok_AbstractLit&&yylval.semval<=tok_BitStringLit)
		Arg2Legal=1;
	else
	{
		int i;
		/* Lets check generics */
		if(What!=COMPONV)
		{
			for(i=0 ; i<SemGlobal->GenericCnt ; i++)
			{
				if(yylval.toknum==SemGlobal->ListOfGenerics[i].LexemId)
				{
					int TypeOf=SemGlobal->ListOfGenerics[i].TypeOf;
					if(TypeOf==INTEGERLV || TypeOf==POSITIVELV || TypeOf==NATURALLV || TypeOf==BITLV || TypeOf==STDULOGICLV || TypeOf==STDLOGICLV)
					{
						right=SemGlobal->ListOfGenerics[i].value;
						isRight=1;
					}
					else
					{
						char typestr[BUFSIZE];
						int BaseType;
						strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
						FindTypeString(TypeOf, typestr, typestr);
						ParentTypeFromLine(typestr, &BaseType);
						switch(BaseType)
						{
						case INTEGERLV:
						case POSITIVELV:
						case NATURALLV:
						case BITLV:
						case STDULOGICLV:
						case CHARLV:
						case STDLOGICLV:
							right=SemGlobal->ListOfGenerics[i].value;
							isRight=1;
						default:
							semerror(ERRUNSGENERIC, NULL);
						}
					}
					isComputedByGeneric=1;
				}
			}
		}
		Arg2Legal=0;/* we aren't sure here, yet! */
	}
	if(!isRight)
		sscanf(yylval.tokstr, "%d", &right);
	right*=right_sign;
	/* check it with base TYPE */
	
	/* Very Important */
	sscanf(typestr, "%d", &toknum);
	if(Arg1Legal && Arg2Legal)
	{
		int BitsCnt;
		if( to_or_downto==tok_TO)
		{
			if(isInArray)
				BitsCnt=right-left+1;
			else
			{
				BitsCnt=HowManyBitsInt(left, right); /* is it null slice? */
			}
			if(isComputedByGeneric && What==ENTITYV)
				BitsCnt=-1;
			sprintf( typestr,"%d\t%d\t%d\t%d\t%d\t%d",
				toknum, decl_status.Class, decl_status.mode,
				BitsCnt,
				min(left,right), max(left,right)
				); 
		}
		else
		{
			if(isInArray)
				BitsCnt=left-right+1;
			else
				BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
			if(isComputedByGeneric && What==ENTITYV)
				BitsCnt=-1;
			sprintf( typestr,"%d\t%d\t%d\t%d\t%d\t%d",
				toknum, decl_status.Class, decl_status.mode,
				BitsCnt,
				max(left,right), min(left,right)
				);
		}
	}
	else
	{
		while(yylex()!=tok_RightParen)
		{
			ParseExpression(&right);
			if(yylval.semval==tok_Semicolon)
			{
				isSemicolonRead=1;
				break;
			}
			NextYY();
		}
		if(yylval.semval==tok_RightParen)
			SemGlobal->isRightParenAlreadyRead=1;
		if(isRight && Arg1Legal)
		{
			int BitsCnt;
			Arg2Legal=1;
			if( to_or_downto==tok_TO)
			{
				if(isInArray)
					BitsCnt=right-left+1;
				else
					BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
				if((isComputedByGeneric && What==ENTITYV) || SemGlobal->isComponentPort)
					BitsCnt=-1;
				sprintf( typestr,"%d\t%d\t%d\t%d\t%d\t%d",
					toknum, decl_status.Class, decl_status.mode,
					BitsCnt,
					min(left,right), max(left,right)
					); 
			}
			else
			{
				if(isInArray)
					BitsCnt=left-right+1;
				else
					BitsCnt=HowManyBitsInt(right, left); /* is it null slice? */
				if((isComputedByGeneric && What==ENTITYV) || SemGlobal->isComponentPort)
					BitsCnt=-1;
				sprintf( typestr,"%d\t%d\t%d\t%d\t%d\t%d",
					toknum, decl_status.Class, decl_status.mode,
					BitsCnt,
					max(left,right), min(left,right)
					);
			}
			
		}
	}
	//if(!isSemicolonRead)
	//	ReadToSemiC();

	if(Arg1Legal && Arg2Legal)
	{
		FreeListOfYY();
		return 0;
	}
	else 
		return 1;
}//GetSliceOfTypeForEntity

void ReduceTo6Cols(char *typestr)
{
	int ColCnt=0;
	char *t;
	t=typestr;
	while(ColCnt<6)
	{
		while(*t!='\n' && *t!='\t' && *t!=' ' && *t!=0)
			t++;
		if(*t=='\n' || *t==0)
			break;
		ColCnt++;
		t++;
	}
	*t=0;
}

/*It makes most of the work of semantical analysis, i.e. it parses
 * declarative part of current rank*/
//Nowa wersja - 04 kwiecien 2000
int ParseDeclarativePart(FILE *semantics)
{
	int idnum, hasSpecialSlice, i, IsTypeComputable, isAlias=0, ltoknum;
	char TmpStrDescr[NAMESIZE];
	char idstr[1024], typestr[65535];
	stack_id portlist=NULL;
	SemGlobal->isInValFile=0;
	while(1) //yylval.semval != tok_END)
    {
		switch(yylval.semval)
		{
			case tok_Comma		:
			case tok_Colon		:break;
			case tok_SIGNAL	:SemGlobal->isInValFile=1;decl_status.Class=1; break;
			case tok_CONSTANT	:SemGlobal->isInValFile=1;ParseConstantDeclaration(semantics);break;
			case tok_ALIAS		:SemGlobal->isInValFile=1;isAlias=1;decl_status.Class=1; break;
			case tok_SHARED	:
			case tok_VARIABLE	:SemGlobal->isInValFile=1;decl_status.Class=0; break;
			case tok_TYPE		:
				if(ParseTypeDeclaration()==IGNOREDTYPE)
					return 0;
				break;
			
			// Build the stack of identifiers with the same type 
			case tok_Identifier :stack_push(&portlist, yylval.toknum, yylval.tokstr);
				break;
			default: printf("Data type not supported or not yet implemented!\n"
							"Error appeared in line: %d\n", yylval.line+1);
				exit(-1);
		}
		if( yylval.semval != tok_Colon)
		{
			yylex();
			continue;
		}
		// Type description expected 
		IsTypeComputable=NewGetTypeString(typestr);
		hasSpecialSlice=0;
		if(yylval.semval==tok_VarAsgn)
			ReadToSemiC();
		if( yylval.semval==tok_RANGE || yylval.semval==tok_LeftParen)
			hasSpecialSlice=GetSliceOfType(typestr);
		// Reducing stack of identifiers 
		if(hasSpecialSlice!=1)//doesn't has special slice i.e. A'range but can have type in .tnc
		{
			if(IsTypeComputable==2)
			{
				FILE *ncmpfile, *tmpncmpfile;
				char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE], TmpLexemStr[NAMESIZE];
				int lBaseType, lMode, lTypeOf, Arg1No, Arg2No, OpenParenCnt;
				Arg1No=0;Arg2No=0;
				sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
				if(SemGlobal->hasNonComputables)
					ncmpfile=fopen(NotComputablePath, "at");
				else
					ncmpfile=fopen(NotComputablePath, "wt");
				SemGlobal->hasNonComputables=1;
				if(!ncmpfile)
					return -1;
				sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
				WriteLastLexemId(TmpLexemStr);
				Arg1No=SemGlobal->LastLexemId+200;
				fprintf(ncmpfile, "; %d\n", Arg1No);
				OpenParenCnt=0;
				sscanf(typestr, "%d", &ltoknum);;
				LexemStringDescr(ltoknum, TmpStrDescr);
				fprintf(ncmpfile, "%s\n", TmpStrDescr);
				fprintf(ncmpfile, "224\tidentifier:\t'low\n");
				fprintf(ncmpfile, "114\tspecial_character:\t;\n");
				sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
				WriteLastLexemId(TmpLexemStr);
				Arg2No=SemGlobal->LastLexemId+200;
				fprintf(ncmpfile, "; %d\n", Arg2No);
				LexemStringDescr(ltoknum, TmpStrDescr);
				fprintf(ncmpfile, "%s\n", TmpStrDescr);
				fprintf(ncmpfile, "223\tidentifier:\t'high\n");
				fprintf(ncmpfile, "114\tspecial_character:\t;\n");




				fclose(ncmpfile);
				sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);
				
				if(SemGlobal->hasNonComputables)
					tmpncmpfile=fopen(TmpNotComputablePath, "at");
				else
					tmpncmpfile=fopen(TmpNotComputablePath, "wt");
				if(!tmpncmpfile)
					return -1;
				while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
				{
					sscanf(typestr, "%d\t%d\t%d", &lBaseType, &lMode, &lTypeOf);
					fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t0\n", idnum, idstr, lBaseType, lMode, lTypeOf, Arg1No, Arg2No);
				}
				fclose(tmpncmpfile);
			}
			else
			{
				while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
				{
					ReduceTo6Cols(typestr);
					if(SemGlobal->isInValFile && SemGlobal->roottype!=TYPEPACK)
						CheckNewName(idstr, &idnum, TYPEV);
					fprintf( semantics, "%d\t%s\t%s\n", idnum, idstr, typestr);
				}
			}
		}
		else//has special slice i.e. A'range
		{
			FILE *ncmpfile, *tmpncmpfile;
			char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE];
			char TmpLexemStr[NAMESIZE];
			int lBaseType, lMode, lTypeOf, Arg1No, Arg2No, OpenParenCnt;
			Arg1No=0;Arg2No=0;
			sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
			if(SemGlobal->hasNonComputables)
				ncmpfile=fopen(NotComputablePath, "at");
			else
				ncmpfile=fopen(NotComputablePath, "wt");
			SemGlobal->hasNonComputables=1;
			if(!ncmpfile)
				return -1;
			sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
			WriteLastLexemId(TmpLexemStr);
			Arg1No=SemGlobal->LastLexemId+200;
			fprintf(ncmpfile, "; %d\n", Arg1No);
			OpenParenCnt=0;
			for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
			{
				if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
					OpenParenCnt++;
				if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
				{
					if(OpenParenCnt<1)
						continue;
					OpenParenCnt--;
				}
				if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
				{
					sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
					WriteLastLexemId(TmpLexemStr);
					Arg2No=SemGlobal->LastLexemId+200;
					fprintf(ncmpfile, "114\tspecial_character:\t;\n");
					fprintf(ncmpfile, "; %d\n", Arg2No);
					OpenParenCnt=0;
				}
				else
				{
					LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
					fprintf(ncmpfile, "%s\n", TmpStrDescr);
				}
			}
			fprintf(ncmpfile, "114\tspecial_character:\t;\n");
			fclose(ncmpfile);
			sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);

			if(SemGlobal->hasNonComputables)
				tmpncmpfile=fopen(TmpNotComputablePath, "at");
			else
				tmpncmpfile=fopen(TmpNotComputablePath, "wt");
			if(!tmpncmpfile)
				return -1;
			/* toknum - znany w czasie kompilacji
			 * name - znane w czasie kompilacji
			 * mode - znany w czasie kompilacji
			 * typeof - znany w czasie kompilacji
			 * nrofbits - nieznany w czasie kompilacji
			 * left -  nieznany w czasie kompilacji
			 * right - nieznany w czasie kompilacji
			 * jesli right=0, to left okresla 
			 */
			while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
			{
				sscanf(typestr, "%d\t%d\t%d", &lBaseType, &lMode, &lTypeOf);
				fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t0\n", idnum, idstr, lBaseType, lMode, lTypeOf, Arg1No, Arg2No);
			}
			fclose(tmpncmpfile);

			FreeListOfYY();
		}
		switch( yylval.semval)
		{
			case tok_SIGNAL		:decl_status.Class=1; break;
			case tok_VARIABLE	:decl_status.Class=0; break;
			case tok_TYPE		:
			default				:break; 
/* po sredniku moze nastapic signal, var, function lub procedure itp.
   sterowaniem odczytem ich wartosci zajmuja sie funkcje na wyzszym poziomie*/
		}
		break;
    }
	if(isAlias)
	{
		int Cnt, value;
		char tmpstr[NAMESIZE], bufor[BUFSIZE];
		/*Lexem aliasu + przypisanie*/
		SemGlobal->ListForAlias=(YYSTYPE*)malloc(2*sizeof(YYSTYPE));
		SemGlobal->ListForAlias[0].toknum=idnum;
		sprintf(tmpstr, "%d\tidentifier:\t%s\n", idnum, idstr);
		strcpy(SemGlobal->ListForAlias[0].tokstr, tmpstr);
		SemGlobal->ListForAlias[1].toknum=171;
		strcpy(SemGlobal->ListForAlias[1].tokstr,"171\tdouble_char_symbol:\t<=\n");
		Cnt=2;
		while(fgets(bufor, BUFSIZE, SemGlobal->srcf))
		{
			value=getvalue(bufor, NULL);
			SemGlobal->ListForAlias=(YYSTYPE*)realloc((YYSTYPE*)SemGlobal->ListForAlias, (Cnt+1)*sizeof(YYSTYPE));
			SemGlobal->ListForAlias[Cnt].toknum=value;
			strcpy(SemGlobal->ListForAlias[Cnt].tokstr, bufor);
			Cnt++;
			if(value==SEMICV)
				break;
		}
	}
	return 0;
}


int ParseDeclarativePartRDNewVersion(FILE *semantics)
{
	int idnum;
	char idstr[1024], typestr[65535];
	stack_id portlist=NULL;
//	SkipFile(semantics);
	while( yylval.semval != tok_BEGIN)
    {
		fflush(semantics);
//		decl_status.mode=3;
		switch(yylval.semval)
		{
		case tok_Comma      :
		case tok_Colon      :break;
		case tok_SIGNAL     :decl_status.Class=1; break;
//		case tok_CONSTANT   :ParseConstantDeclaration(semantics);break;
		case tok_SHARED     :
		case tok_VARIABLE   :decl_status.Class=0; break;
		case tok_TYPE       :ParseTypeDeclaration(); break;
		case tok_PROCEDURE  :fflush(semantics);
//			ParseProcedureDeclaration(semantics,processnum); 
			break;
			/* Build the stack of identifiers with the same type */
		case tok_Identifier :stack_push(&portlist, yylval.toknum, yylval.tokstr);
			break;
		default: printf("Data type not supported or not yet implemented!\n"
					 "Error appeared in line: %d\n", yylval.line+1);
			exit(-1);
		}
		if( yylval.semval != tok_Colon)
		{
			yylex();
			continue;
		}
		/* Type description expected */
		GetTypeString(typestr);
		/* Reducing stack of identifiers */
		while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
			fprintf( semantics, "%d\t%s\t%s\n", idnum, idstr, typestr);
		assert(!fflush(semantics));
//		decl_status.mode=3;
		switch( yylval.semval)
		{
		case tok_SIGNAL     :decl_status.Class=1; break;
		case tok_VARIABLE   :decl_status.Class=0; break;
		case tok_TYPE       :break;
		default             :yylex(); break; /* tok_BEGIN is read */
		}
    }
	return 0;
}





int ParseDeclarativePartOldVersion(FILE *semantics)
{
	int idnum;
	char idstr[1024], typestr[65535];
	stack_id portlist=NULL;
	while(1) //yylval.semval != tok_END)
    {
		switch(yylval.semval)
		{
			case tok_Comma      :
			case tok_Colon      :break;
			case tok_SIGNAL     :decl_status.Class=1; break;
			case tok_VARIABLE   :decl_status.Class=0; break;
			case tok_TYPE       :ParseTypeDeclaration(); break;
				// Build the stack of identifiers with the same type 
			case tok_Identifier :stack_push(&portlist, yylval.toknum, yylval.tokstr);
				break;
			default: printf("Data type not supported or not yet implemented!\n"
						 "Error appeared in line: %d\n", yylval.line+1);
				exit(-1);
		}
		if( yylval.semval != tok_Colon)
		{
			yylex();
			continue;
		}
		// Type description expected 
		GetTypeString(typestr);
		// Reducing stack of identifiers 
		while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
			fprintf( semantics, "%d\t%s\t%s\n", idnum, idstr, typestr);
		switch( yylval.semval)
		{
			case tok_SIGNAL     :decl_status.Class=1; break;
			case tok_VARIABLE   :decl_status.Class=0; break;
			case tok_TYPE       :
			default             :break; 
/* po sredniku moze nastapic signal, var, function lub procedure itp.
   sterowaniem odczytem ich wartosci zajmuja sie funkcje na wyzszym poziomie*/
		}
		break;
    }
	return 0;
}
