#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#ifndef _MSC_VER
  #include <unistd.h>
#else
  #include <direct.h>
#endif
#include <string.h>
#include <sys/stat.h>
#include "vhdl_tab.h"
#include "stack.h"
#include "semval.h"
#include "tstst.h"
#include "semerr.h"


DECL_STATUS decl_status;
extern YYSTYPE yylval;
extern struct PBGLOBAL *SemGlobal;

void NewEntityPort(int *idnum, char *idstr)
{
	int i, tmpid;
	if(!SemGlobal->ileencji)
		return;
	i=SemGlobal->entities[SemGlobal->ileencji-1].portcnt;
	if(i==0)
	{
		SemGlobal->entities[SemGlobal->ileencji-1].portcnt=1;
		SemGlobal->entities[SemGlobal->ileencji-1].portids=(int*) malloc (sizeof(int));
		SemGlobal->entities[SemGlobal->ileencji-1].portids[0]=*idnum;
		SemGlobal->entities[SemGlobal->ileencji-1].isbuffers=(int*) malloc (sizeof(int));
		SemGlobal->entities[SemGlobal->ileencji-1].isbuffers[0]=SemGlobal->DoesLastIsBuffer;
	}
	else
	{
		int j, *tmpids;
		SemGlobal->entities[SemGlobal->ileencji-1].portcnt++;
		tmpids=(int*) malloc ((i+1) * sizeof(int) );
		for(j=0 ; j<i ; j++)
			tmpids[j]=SemGlobal->entities[SemGlobal->ileencji-1].portids[j];
		free(SemGlobal->entities[SemGlobal->ileencji-1].portids);
		SemGlobal->entities[SemGlobal->ileencji-1].portids=tmpids;
		SemGlobal->entities[SemGlobal->ileencji-1].portids[i]=*idnum;
		tmpids=(int*) malloc((i+1)*sizeof(int));
		for(j=0 ; j<i ; j++)
			tmpids[j]=SemGlobal->entities[SemGlobal->ileencji-1].isbuffers[j];
		free(SemGlobal->entities[SemGlobal->ileencji-1].isbuffers);
		SemGlobal->entities[SemGlobal->ileencji-1].isbuffers=tmpids;
		SemGlobal->entities[SemGlobal->ileencji-1].isbuffers[i]=SemGlobal->DoesLastIsBuffer;
	}
	tmpid=*idnum;
	CheckNewName(idstr, idnum, ENTITYV);
	if(*idnum!=tmpid)
	{
		int ie, cnt;
		SemGlobal->entities[SemGlobal->ileencji-1].portids[i]=*idnum;
		ie=SemGlobal->ileencji-1;//index ostatniej jednostki
		cnt=SemGlobal->entities[ie].modifierscnt;//ilosc wystepujcej w tej jednostce modyfikatorow
		if(cnt)
			SemGlobal->entities[ie].modifiers=
			(MODIFIERS*)realloc((MODIFIERS*)SemGlobal->entities[ie].modifiers,
			(cnt+1)*sizeof(MODIFIERS));
		else
			SemGlobal->entities[ie].modifiers=
			(MODIFIERS*)malloc(sizeof(MODIFIERS));
		SemGlobal->entities[ie].modifiers[cnt].origlexno=tmpid;
		SemGlobal->entities[ie].modifiers[cnt].modlexno=*idnum;
		strcpy(SemGlobal->entities[ie].modifiers[cnt].ModifiedName, idstr);
		SemGlobal->entities[ie].modifiers[cnt].level=SemGlobal->varlevel;
		SemGlobal->entities[ie].modifierscnt++;//jest juz caly nowy modyfikator
	}
}

int WriteNonComputable(int idnum, char *idstr, char *typestr)
{
	FILE *ncmpfile;
	char NotComputablePath[PATHSIZE];
	sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
	if(SemGlobal->hasNonComputables)
		ncmpfile=fopen(NotComputablePath, "at");
	else
		ncmpfile=fopen(NotComputablePath, "wt");
	SemGlobal->hasNonComputables=1;
	if(!ncmpfile)
		return -1;
	
	fclose(ncmpfile);
	return 0;
}//WriteNonComputable

void AddNewNameToComponent(int origidnum, int idnum, char *idstr)
{
	int i, j, isAlready=0;
	for(i=0 ; i<SemGlobal->ChangedComcnt ; i++)
	{
		if(!stricmp(SemGlobal->ChangedCom[i].name, SemGlobal->actcompo))
		{
			isAlready=1;
			j=SemGlobal->ChangedCom[i].modifierscnt;
			SemGlobal->ChangedCom[i].modifiers=
				(MODIFIERS*)realloc(
				(MODIFIERS*)SemGlobal->ChangedCom[i].modifiers,
				sizeof(MODIFIERS)*(j+1));
			SemGlobal->ChangedCom[i].modifiers[j].isInArchitecture=0;
			SemGlobal->ChangedCom[i].modifiers[j].level=SemGlobal->varlevel;
			strcpy(SemGlobal->ChangedCom[i].modifiers[j].ModifiedName, idstr);
			SemGlobal->ChangedCom[i].modifiers[j].modlexno=idnum;
			SemGlobal->ChangedCom[i].modifiers[j].origlexno=origidnum;
			SemGlobal->ChangedCom[i].modifierscnt++;
			break;
		}
	}
	if(!isAlready)
	{
		int i;
		i=SemGlobal->ChangedComcnt;
		if(i)
			SemGlobal->ChangedCom=(CHANGEDCOM*)realloc((CHANGEDCOM*)SemGlobal->ChangedCom, sizeof(CHANGEDCOM)*(i+1));
		else
			SemGlobal->ChangedCom=(CHANGEDCOM*)malloc(sizeof(CHANGEDCOM));
		strcpy(SemGlobal->ChangedCom[i].name, SemGlobal->actcompo);
		SemGlobal->ChangedCom[i].modifiers=(MODIFIERS*)malloc(sizeof(MODIFIERS));
		SemGlobal->ChangedCom[i].modifiers[0].isInArchitecture=0;
		SemGlobal->ChangedCom[i].modifiers[0].level=SemGlobal->varlevel;
		strcpy(SemGlobal->ChangedCom[i].modifiers[0].ModifiedName, idstr);
		SemGlobal->ChangedCom[i].modifiers[0].modlexno=idnum;
		SemGlobal->ChangedCom[i].modifiers[0].origlexno=origidnum;
		SemGlobal->ChangedCom[i].modifierscnt=1;
		SemGlobal->ChangedComcnt++;
	}
}//AddNewNameToComponent




void CheckNamesInEntity(int *idnum, char *idstr)
{
	int i, j;
	int hasEntity=0;
	for(i=0 ; i<SemGlobal->ileencji ; i++)
	{
		if(!stricmp(SemGlobal->entities[i].name, SemGlobal->actcompo))
		{
			hasEntity=1;
			for(j=0 ; j<SemGlobal->entities[i].modifierscnt ; j++)
			{
				if(*idnum == SemGlobal->entities[i].modifiers[j].origlexno)
				{
					strcpy(idstr, SemGlobal->entities[i].modifiers[j].ModifiedName);
					*idnum=SemGlobal->entities[i].modifiers[j].modlexno;
					break;
				}
			}
			break;
		}
	}
	if(!hasEntity)
	{
		int tmpidnum=*idnum;
		CheckNewName(idstr, idnum, COMPONV);
		if(tmpidnum!=*idnum)
		{
			AddNewNameToComponent(tmpidnum, *idnum, idstr);
			//Dolozenie do entity zmodyfikowanego sygnalu
			//Poniewaz entity nie istnieje konieczne jest pozniejsze
			//zsynchronizowanie nazw sygnalow w komponencie i jednostce
		}
	}
	return;
}


int ParseEntityPortList(char *path, int What)
{
	int idnum, hasSpecialSlice, defaultmode, IsTypeComputable, ltoknum;
	char idstr[255], TmpStrDescr[NAMESIZE];
	FILE *entityport;
	stack_id portlist=NULL;
	stack_id tmpportlist=NULL;
	char typestr[65535], portpath[PATHSIZE];
	defaultmode=SemGlobal->defaultmode;
	SemGlobal->defaultmode=1;/* default mode IN */
	sprintf(portpath, "%s.val", path);
	entityport=fopen(portpath, "at");
	if(!entityport)
		return -1;
    decl_status.Class=1;
    /* skip left parenthesis: */
    yylex();
    /* Parsing portlist */
    while( yylex() != tok_Semicolon)
	{
		if( yylval.semval==tok_TYPE)
			break;
		switch(yylval.semval)
        {
        case tok_Comma      :
        case tok_Colon      :break;
			/* Build the stack of identifiers with the same type */
        case tok_Identifier :stack_push( &portlist, yylval.toknum, yylval.tokstr);
			break;
        }
		if( yylval.semval != tok_Colon)
			continue;
		/* Type description expected */
		IsTypeComputable=NewGetTypeString(typestr);
		hasSpecialSlice=0;
		if(yylval.semval==tok_RANGE)
		{
			hasSpecialSlice=GetSliceOfTypeForEntity(typestr, What);
			if(yylval.semval!=tok_Semicolon)
				yylex();/* skip ; or ) in case of last definition of port*/
		}
		if(yylval.semval==tok_LeftParen)
		{
			SemGlobal->isRightParenAlreadyRead=0;
			hasSpecialSlice=GetSliceOfTypeForEntity(typestr, What);
			if(!SemGlobal->isRightParenAlreadyRead)
				yylex();/* skip ; or ) in case of last definition of port*/
			yylex();/* skip ; or ) in case of last definition of port*/
		}
		if(yylval.semval==tok_VarAsgn)
		{
			int ParCnt=0;
			semwarn("Assignment to entity port (ignored)");
			while(yylex()!=tok_Semicolon)
			{
				if(yylval.semval==tok_LeftParen)
					ParCnt++;
				if(yylval.semval==tok_RightParen)
				{
					if(ParCnt==0)
						break;
					ParCnt--;
				}
			}
		}
		if(hasSpecialSlice!=1)//doesn't have special slice i.e. A'range
		{
			if(IsTypeComputable==2)
			{
				FILE *ncmpfile, *tmpncmpfile;
				char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE], TmpLexemStr[NAMESIZE];
				int lBaseType, lMode, lTypeOf, Arg1No, Arg2No, OpenParenCnt;
				Arg1No=0;Arg2No=0;
				sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
				if(SemGlobal->hasNonComputables)
					ncmpfile=fopen(NotComputablePath, "at");
				else
					ncmpfile=fopen(NotComputablePath, "wt");
				SemGlobal->hasNonComputables=1;
				if(!ncmpfile)
					return -1;
				sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
				WriteLastLexemId(TmpLexemStr);
				Arg1No=SemGlobal->LastLexemId+200;
				fprintf(ncmpfile, "; %d\n", Arg1No);
				OpenParenCnt=0;
				sscanf(typestr, "%d", &ltoknum);;
				LexemStringDescr(ltoknum, TmpStrDescr);
				fprintf(ncmpfile, "%s\n", TmpStrDescr);
				fprintf(ncmpfile, "224\tidentifier:\t'low\n");
				fprintf(ncmpfile, "114\tspecial_character:\t;\n");
				sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
				WriteLastLexemId(TmpLexemStr);
				Arg2No=SemGlobal->LastLexemId+200;
				fprintf(ncmpfile, "; %d\n", Arg2No);
				LexemStringDescr(ltoknum, TmpStrDescr);
				fprintf(ncmpfile, "%s\n", TmpStrDescr);
				fprintf(ncmpfile, "223\tidentifier:\t'high\n");
				fprintf(ncmpfile, "114\tspecial_character:\t;\n");
				fclose(ncmpfile);
				sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);

				if(SemGlobal->hasNonComputables)
					tmpncmpfile=fopen(TmpNotComputablePath, "at");
				else
					tmpncmpfile=fopen(TmpNotComputablePath, "wt");
				if(!tmpncmpfile)
					return -1;
				while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
				{
					if(What==ENTITYV)
						NewEntityPort(&idnum, idstr);
					if(What==COMPONV)
						CheckNamesInEntity(&idnum, idstr);
					sscanf(typestr, "%d\t%d\t%d", &lBaseType, &lMode, &lTypeOf);
					fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t0\n", idnum, idstr, lBaseType, lMode, lTypeOf, Arg1No, Arg2No);
				}
				fclose(tmpncmpfile);
			}
			else
			{
				/* Reversing stack of identifiers*/
				while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
					stack_push( &tmpportlist, idnum, idstr);
				/* Reducing stack of identifiers */
				while( stack_pop( &tmpportlist, &idnum, idstr)!=EMPTY_STACK)
				{
					if(What==ENTITYV)
						NewEntityPort(&idnum, idstr);
					if(What==COMPONV)
						CheckNamesInEntity(&idnum, idstr);
					fprintf(entityport,"%d\t%s\t%s\n",idnum,idstr,typestr);
				}
			}
		}
		else//has special slice i.e. A'range
		{
			FILE *ncmpfile, *tmpncmpfile;
			char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE];
			char TmpLexemStr[NAMESIZE];
			int i, lBaseType, lMode, lTypeOf, Arg1No, Arg2No, OpenParenCnt;
			Arg1No=0;Arg2No=0;
			sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
			if(SemGlobal->hasNonComputables)
				ncmpfile=fopen(NotComputablePath, "at");
			else
				ncmpfile=fopen(NotComputablePath, "wt");
			SemGlobal->hasNonComputables=1;
			if(!ncmpfile)
				return -1;
			sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
			WriteLastLexemId(TmpLexemStr);
			Arg1No=SemGlobal->LastLexemId+200;
			fprintf(ncmpfile, "; %d\n", Arg1No);
			OpenParenCnt=0;
			for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
			{
				if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
					OpenParenCnt++;
				if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
				{
					if(OpenParenCnt<1)
						continue;
					OpenParenCnt--;
				}
				if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
				{
					sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
					WriteLastLexemId(TmpLexemStr);
					Arg2No=SemGlobal->LastLexemId+200;
					fprintf(ncmpfile, "114\tspecial_character:\t;\n");
					fprintf(ncmpfile, "; %d\n", Arg2No);
					OpenParenCnt=0;
				}
				else
				{
					char TmpStrDescr[NAMESIZE];
					LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
					fprintf(ncmpfile, "%s\n", TmpStrDescr);
				}
			}
			fprintf(ncmpfile, "114\tspecial_character:\t;\n");
			fclose(ncmpfile);
			sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);
			
			if(SemGlobal->hasNonComputables)
				tmpncmpfile=fopen(TmpNotComputablePath, "at");
			else
				tmpncmpfile=fopen(TmpNotComputablePath, "wt");
			if(!tmpncmpfile)
				return -1;
				/* toknum - znany w czasie kompilacji
				* name - znane w czasie kompilacji
				* mode - znany w czasie kompilacji
				* typeof - znany w czasie kompilacji
				* nrofbits - nieznany w czasie kompilacji
				* left -  nieznany w czasie kompilacji
				* right - nieznany w czasie kompilacji
				* jesli right=0, to left okresla 
			*/
			/* Reversing stack of identifiers*/
			while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
				stack_push( &tmpportlist, idnum, idstr);
			/* Reducing stack of identifiers */
			while( stack_pop( &tmpportlist, &idnum, idstr)!=EMPTY_STACK)
			{
				if(What==ENTITYV)
					NewEntityPort(&idnum, idstr);//tutaj tez moze byc konieczne zmienieanie nazw
				if(What==COMPONV)
					CheckNamesInEntity(&idnum, idstr);
				sscanf(typestr, "%d\t%d\t%d", &lBaseType, &lMode, &lTypeOf);
				fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t0\n", idnum, idstr, lBaseType, lMode, lTypeOf, Arg1No, Arg2No);
			}
			fclose(tmpncmpfile);
			FreeListOfYY();
		}
	}
    /* Entity portlist succesfully parsed */
	fclose(entityport);
	SemGlobal->defaultmode=defaultmode;
	return 0;
}//ParseEntityPortList


int RecordDeclarationParse(FILE *tfile)
{
	int idnum, hasSpecialSlice, lexcnt, lmode;
	char idstr[255];
	stack_id portlist=NULL;
	stack_id tmpportlist=NULL;
	char typestr[65535];

	lmode=SemGlobal->defaultmode;
	SemGlobal->defaultmode=0;/* default mode NoCheck */
	
	decl_status.Class=1;
	lexcnt=0;
	
	while(yylex()!=tok_END)
	{
		switch(yylval.semval)
		{
		case tok_Comma      :
		case tok_Colon      :break;
			/* Build the stack of identifiers with the same type */
		case tok_Identifier :stack_push( &portlist, yylval.toknum, yylval.tokstr);
			lexcnt++;
			break;
		}
		if( yylval.semval != tok_Colon)
			continue;
		/* Type description expected */
		NewGetTypeString(typestr);
		hasSpecialSlice=0;
		if(yylval.semval==tok_RANGE)
		{
			hasSpecialSlice=GetSliceOfTypeForEntity(typestr, RECORDV);
			yylex();/* skip ;*/
		}
		if(yylval.semval==tok_LeftParen)
		{
			SemGlobal->isRightParenAlreadyRead=0;
			hasSpecialSlice=GetSliceOfTypeForEntity(typestr, RECORDV);
			if(!SemGlobal->isRightParenAlreadyRead)
				yylex();/* skip )*/
			yylex();/* skip ;*/
		}
		if(hasSpecialSlice!=1)//doesn't has special slice i.e. A'range
		{
			/* Reversing stack of identifiers*/
			while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
				stack_push( &tmpportlist, idnum, idstr);
			/* Reducing stack of identifiers */
			while( stack_pop( &tmpportlist, &idnum, idstr)!=EMPTY_STACK)
			{
				fprintf(tfile,"%d\t%s\t%s\n",SemGlobal->LastLexemId+200,idstr,typestr);
				WriteLastLexemId(idstr);
			}
		}
		else//has special slice i.e. A'range
		{
			FILE *ncmpfile, *tmpncmpfile;
			char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE];
			char TmpLexemStr[NAMESIZE];
			int i, lBaseType, lMode, lTypeOf, Arg1No, Arg2No, OpenParenCnt;
			Arg1No=0;Arg2No=0;
			sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
			if(SemGlobal->hasNonComputables)
				ncmpfile=fopen(NotComputablePath, "at");
			else
				ncmpfile=fopen(NotComputablePath, "wt");
			SemGlobal->hasNonComputables=1;
			if(!ncmpfile)
				return -1;
			sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
			WriteLastLexemId(TmpLexemStr);
			Arg1No=SemGlobal->LastLexemId+200;
			fprintf(ncmpfile, "; %d\n", Arg1No);
			OpenParenCnt=0;
			for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
			{
				if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
					OpenParenCnt++;
				if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
				{
					if(OpenParenCnt<1)
						continue;
					OpenParenCnt--;
				}
				if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
				{
					sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
					WriteLastLexemId(TmpLexemStr);
					Arg2No=SemGlobal->LastLexemId+200;
					fprintf(ncmpfile, "114\tspecial_character:\t;\n");
					fprintf(ncmpfile, "; %d\n", Arg2No);
					OpenParenCnt=0;
				}
				else
				{
					char TmpStrDescr[NAMESIZE];
					LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
					fprintf(ncmpfile, "%s\n", TmpStrDescr);
				}
			}
			fprintf(ncmpfile, "114\tspecial_character:\t;\n");
			fclose(ncmpfile);
			sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);
			
			if(SemGlobal->hasNonComputables)
				tmpncmpfile=fopen(TmpNotComputablePath, "at");
			else
				tmpncmpfile=fopen(TmpNotComputablePath, "wt");
			if(!tmpncmpfile)
				return -1;
				/* toknum - znany w czasie kompilacji
				* name - znane w czasie kompilacji
				* mode - znany w czasie kompilacji
				* typeof - znany w czasie kompilacji
				* nrofbits - nieznany w czasie kompilacji
				* left -  nieznany w czasie kompilacji
				* right - nieznany w czasie kompilacji
				* jesli right=0, to left okresla 
			*/
			/* Reversing stack of identifiers*/
			while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
				stack_push( &tmpportlist, idnum, idstr);
			/* Reducing stack of identifiers */
			while( stack_pop( &portlist, &idnum, idstr)!=EMPTY_STACK)
			{
				sscanf(typestr, "%d\t%d\t%d", &lBaseType, &lMode, &lTypeOf);
				fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t0\n", SemGlobal->LastLexemId+200, idstr, lBaseType, lMode, lTypeOf, Arg1No, Arg2No);
				WriteLastLexemId(idstr);
			}
			fclose(tmpncmpfile);
			FreeListOfYY();
		}
	}
	while(yylex()!=tok_Semicolon);
	SemGlobal->defaultmode=lmode;
	return lexcnt;
}//RecordDeclarationParse



int WriteSubtypeInfo(FILE **tfile, int SliceBaseType)
{
	int isLeftParen, left, right, ltoknum, isComplexType=0, ValidBits, retval, typenumber;
	char tpath[PATHSIZE], typestr[BUFSIZE], TmpName[NAMESIZE], SliceTypeStr[BUFSIZE], TypeOf[10];
	sprintf(tpath, "%s.tdf", SemGlobal->actpath);
	isLeftParen=1;
	retval=GetSliceOfTypeForSubtype(yylval.tokstr);
	strcpy(typestr, yylval.tokstr);
	sscanf(yylval.tokstr, "%s\t%d\t%d\t%d", SliceTypeStr, &ValidBits, &left, &right);
	/* Generate new tmp lexem for subtype and parse it*/
	sprintf(TmpName, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
	WriteLastLexemId(TmpName);
	ltoknum=SemGlobal->LastLexemId+200;
	typenumber=ltoknum;
	SemGlobal->LastFoundValue=typenumber;
	switch(SliceBaseType)
	{
	case 201:
	case 207:
	case 208:strcpy(TypeOf, "INT");break;
	case 202:
	case 209:
	case 210:
	case 216:
	case 217:
	case 218:
	case 219:strcpy(TypeOf, "BIT");break;
	case 203:
	case 211:
	case 212:strcpy(TypeOf, "BVECT");break;
	case 204:strcpy(TypeOf, "BOOL");break;
	case 205:strcpy(TypeOf, "CHAR");break;
	case 206:strcpy(TypeOf, "STRING");break;
	default:isComplexType=1;break;//Read it from SliceBaseType
	}
	if(!retval)
	{
		if(!SemGlobal->NCofNC)
			fprintf(*tfile, "%d\t0\n%d\t", ltoknum, ltoknum);
		else
			fprintf(*tfile, "%d\t", ltoknum);
		if(isComplexType)
		{
			char ltypestr[BUFSIZE];
			fclose(*tfile);
			strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
			if(FindTypeString(SliceBaseType, ltypestr, SliceTypeStr)!=-1)
				strcpy(TypeOf, SemGlobal->basetype);
			else
				strcpy(TypeOf, "BVECT");
			*tfile=fopen(tpath, "at");
		}
		fprintf( *tfile,"%s\t%s\t%d\t%d\t%d\t0\t%d\n",
			TmpName, TypeOf, ValidBits, left, right, SliceBaseType);
	}
	else//has special slice i.e. A'range
	{
		FILE *ncmpfile, *tmpncmpfile;
		char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE], TmpLexemStr[NAMESIZE];
		int i, Arg1No, Arg2No, OpenParenCnt;
		if(!SemGlobal->NCofNC)
			fprintf(*tfile, "%d\t0\n", ltoknum);
		Arg1No=0;Arg2No=0;
		sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
		if(SemGlobal->hasNonComputables)
			ncmpfile=fopen(NotComputablePath, "at");
		else
			ncmpfile=fopen(NotComputablePath, "wt");
		if(!ncmpfile)
			return -1;
		sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
		WriteLastLexemId(TmpLexemStr);
		Arg1No=SemGlobal->LastLexemId+200;
		fprintf(ncmpfile, "; %d\n", Arg1No);
		OpenParenCnt=0;
		for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
		{
			if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
				OpenParenCnt++;
			if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
			{
				if(OpenParenCnt<1)
					continue;
				OpenParenCnt--;
			}
			if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
			{
				sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
				WriteLastLexemId(TmpLexemStr);
				Arg2No=SemGlobal->LastLexemId+200;
				fprintf(ncmpfile, "114\tspecial_character:\t;\n");
				fprintf(ncmpfile, "; %d\n", Arg2No);
				OpenParenCnt=0;
			}
			else
			{
				char TmpStrDescr[NAMESIZE];
				LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
				fprintf(ncmpfile, "%s\n", TmpStrDescr);
			}
		}
		fprintf(ncmpfile, "114\tspecial_character:\t;\n");
		fclose(ncmpfile);
		sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);
		if(SemGlobal->hasNonComputables)
			tmpncmpfile=fopen(TmpNotComputablePath, "at");
		else
			tmpncmpfile=fopen(TmpNotComputablePath, "wt");
		if(!tmpncmpfile)
			return -1;
		SemGlobal->hasNonComputables=1;
			/* toknum - znany w czasie kompilacji
			* name - znane w czasie kompilacji
			* mode - znany w czasie kompilacji
			* typeof - znany w czasie kompilacji
			* nrofbits - nieznany w czasie kompilacji
			* left -  nieznany w czasie kompilacji
			* right - nieznany w czasie kompilacji
			* jesli right=0, to left okresla 
		*/
		fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t%s\n", typenumber, TmpName, SliceBaseType, 12, 1, Arg1No, Arg2No, TypeOf);
		fclose(tmpncmpfile);
		FreeListOfYY();
	}
	return 0;
}//WriteSubtypeInfo


int ParseBoundsOfArray(int rangetype, int tmptoknum, int typenumber, FILE **tfile, char *TmpName)
{
	char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE];
	char typestr[BUFSIZE], TmpLexemStr[NAMESIZE];
	FILE *ncmpfile, *tmpncmpfile;
	int IsRangeComputed, Arg1No, Arg2No, OpenParenCnt, i, SliceBaseType;

	IsRangeComputed=GetRangeForArray(typestr, rangetype);
	if(IsRangeComputed)//has special slice i.e. A'range
	{//Zmienic na WriteNonComputable
		//fprintf(tfile, "%d\t0\n", ltoknum);
		Arg1No=0;Arg2No=0;
		sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
		if(SemGlobal->hasNonComputables)
			ncmpfile=fopen(NotComputablePath, "at");
		else
			ncmpfile=fopen(NotComputablePath, "wt");
		if(!ncmpfile)
			return -1;
		sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
		WriteLastLexemId(TmpLexemStr);
		Arg1No=SemGlobal->LastLexemId+200;
		fprintf(ncmpfile, "; %d\n", Arg1No);
		OpenParenCnt=0;
		for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
		{
			if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
				OpenParenCnt++;
			if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
			{
				if(OpenParenCnt<1)
					continue;
				OpenParenCnt--;
			}
			if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
			{
				sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
				WriteLastLexemId(TmpLexemStr);
				Arg2No=SemGlobal->LastLexemId+200;
				fprintf(ncmpfile, "114\tspecial_character:\t;\n");
				fprintf(ncmpfile, "; %d\n", Arg2No);
				OpenParenCnt=0;
			}
			else
			{
				char TmpStrDescr[NAMESIZE];
				LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
				fprintf(ncmpfile, "%s\n", TmpStrDescr);
			}
		}
		fprintf(ncmpfile, "114\tspecial_character:\t;\n");
		fclose(ncmpfile);
		SemGlobal->hasNonComputables=1;
		FreeListOfYY();
		SemGlobal->NCofNC=1;
	}
	else
	{
		fprintf(*tfile,"%d\t%s\t", tmptoknum, TmpName);
		fprintf(*tfile,"ARRAY\t%s\t", typestr);
	}
	/*skip of*/
	yylex();
	/*get type specifier*/
	yylex();
	SliceBaseType=yylval.toknum;
	/* skip ; */
	if(SemGlobal->NCofNC)
	{
		sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);
		if(SemGlobal->hasNonComputables)
			tmpncmpfile=fopen(TmpNotComputablePath, "at");
		else
			tmpncmpfile=fopen(TmpNotComputablePath, "wt");
		if(!tmpncmpfile)
			return -1;
	}
	if(yylex()!=tok_Semicolon)
	{
		WriteSubtypeInfo(tfile, SliceBaseType);
		if(SemGlobal->NCofNC)
		{
			fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\tARRAY\n", typenumber, TmpName, SemGlobal->LastFoundValue, 9, 1, Arg1No, Arg2No);
			fclose(tmpncmpfile);
		}
		/*
		if(!GetSliceOfTypeForSubtype(yylval.tokstr))
		{
		fprintf(tfile, "%d\t0\n", yylval.toknum);
		}
		else//Not Computable Type!!!
		{
		fprintf(tfile, "%d\t0\n", yylval.toknum);
		}
		*/
	}
	else
	{
		if(SemGlobal->NCofNC)
		{
			fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\tARRAY\n", typenumber, TmpName, SliceBaseType, 9, 1, Arg1No, Arg2No);
			fclose(tmpncmpfile);
		}
		else
			fprintf(*tfile, "%d\t0\n", SliceBaseType);
	}
	return 0;
}

int GetOfAndType(char *SliceTypeStr)
{
	int ltoknum;
	char FullType[BUFSIZE];
	/* skip keyword: tok_OF */
	yylex();
	/* get subtype indicator */
	yylex();
	ltoknum=yylval.toknum;
	strcpy(SliceTypeStr, yylval.tokstr);
	strcpy(FullType, yylval.tokstr);
	/* skip tok_Semicolon or get subtype range*/
	yylex();
	if(yylval.semval==tok_Dot)
	{
		while(!(yylval.semval==tok_LeftParen || yylval.semval==tok_RANGE || yylval.semval==tok_Semicolon))
		{
			strcat(FullType, yylval.tokstr);
			ltoknum=yylval.toknum;
			yylex();
		}
//		if(!strnicmp(FullType, "ieee.std_logic_1164", 19))
//			ltoknum=yylval.toknum;
//		else
//			ltoknum=yylval.toknum;//wyszukiwanie w pozniejszej wersji

	}
	return ltoknum;
}//GetOfAndType

int WriteYYListToNcpList(int tmptoknum, char *TmpName, int TypeOf)
{
	FILE *ncmpfile, *tncfile;
	int Arg1No, Arg2No, i, OpenParenCnt;
	char NotComputablePath[PATHSIZE], TncPath[PATHSIZE], TmpLexemStr[NAMESIZE];
	Arg1No=0;Arg2No=0;
	sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
	sprintf(TncPath, "%s.tnc", SemGlobal->actpath);
	if(SemGlobal->hasNonComputables)
	{
		ncmpfile=fopen(NotComputablePath, "at");
		tncfile=fopen(TncPath, "at");
	}
	else
	{
		ncmpfile=fopen(NotComputablePath, "wt");
		tncfile=fopen(TncPath, "wt");
	}
	if(!ncmpfile)
		return -1;
	if(!tncfile)
		return -1;
	fprintf(tncfile,"%d\t%s\t", tmptoknum, TmpName);//numer i nazwa leksemu
	sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
	WriteLastLexemId(TmpLexemStr);
	Arg1No=SemGlobal->LastLexemId+200;
	fprintf(ncmpfile, "; %d\n", Arg1No);
	OpenParenCnt=0;
	for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
	{
		if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
			OpenParenCnt++;
		if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
		{
			if(OpenParenCnt<1)
				continue;
			OpenParenCnt--;
		}
		if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
		{
			sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
			WriteLastLexemId(TmpLexemStr);
			Arg2No=SemGlobal->LastLexemId+200;
			fprintf(ncmpfile, "114\tspecial_character:\t;\n");
			fprintf(ncmpfile, "; %d\n", Arg2No);
			OpenParenCnt=0;
		}
		else
		{
			char TmpStrDescr[NAMESIZE];
			LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
			fprintf(ncmpfile, "%s\n", TmpStrDescr);
		}
	}
	fprintf(ncmpfile, "114\tspecial_character:\t;\n");
	SemGlobal->hasNonComputables=1;
	FreeListOfYY();
	SemGlobal->NCofNC=1;
	fprintf(tncfile, "%d\t9\t1\t0\t%d\t%d\tARRAY\n", TypeOf, Arg1No, Arg2No);
	fclose(ncmpfile);
	fclose(tncfile);
	return 0;
}//WriteYYListToNcpList



int GetOnlyType(char *SliceTypeStr)
{
	int ltoknum;
	char FullType[BUFSIZE];
	ltoknum=yylval.toknum;
	strcpy(SliceTypeStr, yylval.tokstr);
	strcpy(FullType, yylval.tokstr);
	/* skip tok_Semicolon or get subtype range*/
	if(SemGlobal->TypeCollected!=2)
		yylex();
	if(yylval.semval==tok_Dot)
	{
		while(!(yylval.semval==tok_LeftParen || yylval.semval==tok_RightParen || yylval.semval==tok_RANGE || yylval.semval==tok_Semicolon))
		{
			strcat(FullType, yylval.tokstr);
			strcpy(SemGlobal->LastFullType, FullType);
			strcpy(SliceTypeStr, yylval.tokstr);
			ltoknum=yylval.toknum;
			yylex();
		}
	}
	SemGlobal->TypeCollected=1;
	return ltoknum;
}

int ParseTypeDeclaration(void)
{
	FILE *tfile, *efile;
	char tpath[PATHSIZE], epath[PATHSIZE], mode[3], TmpName[NAMESIZE], SliceTypeStr[BUFSIZE];
	int typenumber=0, ltoknum, tmptoknum, FirstToknum, SliceBaseType, ValidBits, NCofNC=0;
	if(SemGlobal->hasTypes)
		strcpy(mode, "at");//jest juz plik z typami
	else
		strcpy(mode, "wt");//nie ma jeszcze tego pliku
	sprintf(tpath, "%s.tdf", SemGlobal->actpath);
	sprintf(epath, "%s.def", SemGlobal->actpath);
	tfile=fopen(tpath, mode);
	efile=fopen(epath, mode);
	
	assert(tfile);
	/* get type identifier */
	yylex();
	FirstToknum=SemGlobal->LastLexemId+200;
	tmptoknum=yylval.toknum;
	typenumber=yylval.toknum;
	strcpy(TmpName, yylval.tokstr);
	/* skip tok_IS */
	yylex();
	/* type definition begins */
	yylex();
	if(yylval.semval==tok_FILE || !stricmp(yylval.tokstr, "time") || !stricmp(yylval.tokstr, "real"))
	{
		ReadToSemiC();
		return IGNOREDTYPE;
	}

	if(yylval.semval==tok_RECORD)
	{
		FILE *vfile;
		char valpath[PATHSIZE];
		int LenOfRecord;
		sprintf(valpath, "%s.val", SemGlobal->actpath);
		vfile=fopen(valpath, "at");
		LenOfRecord=RecordDeclarationParse(vfile);
		fprintf(tfile,"%d\t%s\tREC\t%d\t%d\t%d\t0\t0\n",
			tmptoknum, TmpName, LenOfRecord, FirstToknum, SemGlobal->LastLexemId+200-1);
		fclose(vfile);
	}
	/*******Integer type definition/declaration   **********/
	if(yylval.semval==tok_RANGE)
	{
		int left, left_sign, right, right_sign, direction;
		/* left limit */
		fprintf(tfile,"%d\t%s\t", tmptoknum, TmpName);
		if( yylex()==tok_Minus)
		{
			left_sign=-1;
			yylex();
		}
		else
			left_sign=1;
		sscanf(yylval.tokstr, "%d", &left);
		left*=left_sign;
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		direction=yylval.semval;
		/* right limit */
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			right_sign=-1;
			yylex();
		}
		else
			right_sign=1;
		sscanf(yylval.tokstr, "%d", &right);
		right*=right_sign;
		fprintf(tfile,"INT\t");
		if( direction == tok_TO)
		{
			if( left < right)
				fprintf(tfile,"%d\t", HowManyBits(max(abs(right), abs(left))));
			else
				fprintf(tfile,"0\t");      
		}
		else
		{
			if( left > right)
				fprintf(tfile,"%d\t", HowManyBits(max(abs(right), abs(left))));
			else
				fprintf(tfile,"0\t");      
		}
		fprintf(tfile,"%d\t%d\t0\t201\n", left, right);   
		//was - fprintf(tfile,"%d\t%d\t0\n", left, right);   
		/* skip tok_Semicolon */
		yylex();
	}
	
	/* 
	*********************************************************
	* Array type definition/declaration                     *
	*********************************************************
	*/
	if(yylval.semval==tok_ARRAY)
	{
		int rangetype=0, hasSpecialSlice=0;
		/* skip : ( */
		yylex();
		/* left limit */
		yylex();
		if(!stricmp("natural", yylval.tokstr) || !stricmp("positive", yylval.tokstr) || !stricmp("integer", yylval.tokstr))
		{
			char TypeOf[8];
			int isComplexType;
			if(!stricmp("natural", yylval.tokstr))
				rangetype=1;//natural
			else
				rangetype=2;//positive
			if(!stricmp("integer", yylval.tokstr))
				rangetype=0;//integer
			yylex();
			if(!stricmp("range", yylval.tokstr))
			{
				/*skip <> or read limits*/
				yylex();
				if(yylval.toknum!=DOUBLETRV)
				{
					ParseBoundsOfArray(rangetype, tmptoknum, typenumber, &tfile, TmpName);
				}
				else
				{
					/*skip )*/
					fprintf(tfile,"%d\t%s\t", tmptoknum, TmpName);
					fprintf(tfile,"ARRAY\t");
					yylex();
					if(rangetype==1)
						fprintf(tfile, "32\t0\t2147483647\t");
					else
						fprintf(tfile, "32\t1\t2147483647\t");
					ltoknum=GetOfAndType(SliceTypeStr);
					if(yylval.semval!=tok_LeftParen && yylval.semval!=tok_RANGE)
						fprintf(tfile,"%d\t0\n",ltoknum);
					else
					{
						/* Generate new tmp lexem for subtype and parse it*/
						/* Zastapic funkcja GetSliceOfType lub podobna*/
						int left, right;
						char typestr[BUFSIZE];
						SliceBaseType=ltoknum;
						sprintf(TmpName, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
						WriteLastLexemId(TmpName);
						ltoknum=SemGlobal->LastLexemId+200;
						fprintf(tfile,"%d\t0\n", ltoknum);
//						sscanf(yylval.tokstr, "%d", &right);
//						right*=right_sign;
						if(yylval.semval==tok_LeftParen)
						{
							strcpy(typestr, "0");
							SemGlobal->isRightParenAlreadyRead=0;
							hasSpecialSlice=GetSliceOfTypeForEntity(typestr, TYPEV);
							if(!SemGlobal->isRightParenAlreadyRead)
								yylex();/* skip ; or ) in case of last definition of port*/
							yylex();/* skip ; or ) in case of last definition of port*/
						}
						else
						{
							/* skip ; */
							yylex();
						}
						
						
						switch(SliceBaseType)
						{
						case 201:
						case 207:
						case 208:strcpy(TypeOf, "INT");break;
						case 202:
						case 209:
						case 210:
						case 216:
						case 217:
						case 218:
						case 219:strcpy(TypeOf, "BIT");break;
						case 203:
						case 211:
						case 212:strcpy(TypeOf, "BVECT");break;
						case 204:strcpy(TypeOf, "BOOL");break;
						case 205:strcpy(TypeOf, "CHAR");break;
						case 206:strcpy(TypeOf, "STRING");break;
						default:isComplexType=1;break;//Read it from SliceBaseType
						}
						if(isComplexType)
						{
							char ltypestr[BUFSIZE];
							fclose(tfile);
							strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
							if(FindTypeString(SliceBaseType, ltypestr, SliceTypeStr)!=-1)
								strcpy(TypeOf, SemGlobal->basetype);
							else
								strcpy(TypeOf, "BVECT");
							tfile=fopen(tpath, "at");
						}
						
						
						if(hasSpecialSlice!=1)//hasn't special slice i.e. A'range
						{
							int r1, r2, r3;
							sscanf(typestr, "%d\t%d\t%d\t%d\t%d\t%d", &r1, &r2, &r3, &ValidBits, &left, &right);
							ValidBits=abs(right-left)+1;
							switch(SliceBaseType)
							{
							case 201:
							case 207:
							case 208:
								ValidBits=right;
								right=max(left,right);
								left=min(left, ValidBits);
								ValidBits=HowManyBits(right-left+1);
								break;
							}							
							
							if(left>right)
							{
								left=max(left,MIN_VHDL_INT);
								right=min(right,MAX_VHDL_INT);
							}
							else
							{
								left=min(left,MAX_VHDL_INT);
								right=max(right,MIN_VHDL_INT);
							}
							
							fprintf( tfile,"%d\t%s\t%s\t%d\t%d\t%d\t0\t%d\n",
								ltoknum, TmpName, TypeOf,
								ValidBits,
								left, right, SliceBaseType
								);
//							fprintf(tfile,"%d\t%s\t%s\n", ltoknum, TmpName, typestr);//finish
						}
						else//has special slice i.e. A'range
						{
							FILE *ncmpfile, *tmpncmpfile;
							char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE];
							char TmpLexemStr[NAMESIZE];
							int i, Arg1No, Arg2No, OpenParenCnt;
							Arg1No=0;Arg2No=0;
							sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
							if(SemGlobal->hasNonComputables)
								ncmpfile=fopen(NotComputablePath, "at");
							else
								ncmpfile=fopen(NotComputablePath, "wt");
							SemGlobal->hasNonComputables=1;
							if(!ncmpfile)
								return -1;
							sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
							WriteLastLexemId(TmpLexemStr);
							Arg1No=SemGlobal->LastLexemId+200;
							fprintf(ncmpfile, "; %d\n", Arg1No);
							OpenParenCnt=0;
							for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
							{
								if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
									OpenParenCnt++;
								if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
								{
									if(OpenParenCnt<1)
										continue;
									OpenParenCnt--;
								}
								if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
								{
									sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
									WriteLastLexemId(TmpLexemStr);
									Arg2No=SemGlobal->LastLexemId+200;
									fprintf(ncmpfile, "114\tspecial_character:\t;\n");
									fprintf(ncmpfile, "; %d\n", Arg2No);
									OpenParenCnt=0;
								}
								else
								{
									char TmpStrDescr[NAMESIZE];
									LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
									fprintf(ncmpfile, "%s\n", TmpStrDescr);
								}
							}
							fprintf(ncmpfile, "114\tspecial_character:\t;\n");
							fclose(ncmpfile);
							sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);
							
							if(SemGlobal->hasNonComputables)
								tmpncmpfile=fopen(TmpNotComputablePath, "at");
							else
								tmpncmpfile=fopen(TmpNotComputablePath, "wt");
							if(!tmpncmpfile)
								return -1;
							fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t%s\n",
								ltoknum, TmpName, SliceBaseType, 12, 1, Arg1No, Arg2No, TypeOf);
							fclose(tmpncmpfile);
							FreeListOfYY();
						}
						
						
						
						
						
						
//						if( to_or_downto==tok_TO)
//						{
//							left=max(left,MIN_VHDL_INT);
//							right=min(right,MAX_VHDL_INT);
//							fprintf( tfile,"%s\t%s\t%d\t%d\t%d\t0\t%d\n",
//								TmpName, TypeOf,
//								ValidBits,
//								left, right, SliceBaseType
//								);
//						}
//						else
//						{
//							left=min(left,MAX_VHDL_INT);
//							right=max(right,MIN_VHDL_INT);
//							fprintf( tfile,"%s\t%s\t%d\t%d\t%d\t0\t%d\n",
//								TmpName, TypeOf,
//								ValidBits,
//								left, right, SliceBaseType
//								); 
//						}

					}//yylval.semval!=tok_LeftParen && yylval.semval!=tok_RANGE)
				}//type is array(integer range<>) of something (m to n)
			}//range
		}//!stricmp("integer", yylval.tokstr) positive i natural
		else
		{

			ParseBoundsOfArray(rangetype, tmptoknum, typenumber, &tfile, TmpName);
			/* skip ) only if LeftParen is open*/
//			if(isLeftParen)
//				yylex();
			/* skip ; */
//			if(yylval.semval!=tok_Semicolon)
//				yylex();
		}
		fclose(tfile);
		fclose(efile);
		SemGlobal->hasTypes=1;
		SemGlobal->NCofNC=0;
		return 0;
	}  

	/* 
	 *********************************************************
	 * Enumeration type definition/declaration               *
	 *********************************************************
	*/
	if(yylval.semval==tok_LeftParen)
    {
		int last=0;
		fprintf(tfile,"%d\t%s\t", tmptoknum, TmpName);
		assert(efile); /* Only for enumaration literals */
		fprintf(tfile,"ENUM\t");
		fprintf(efile, "%d\t", typenumber);
		while(yylex()!=tok_RightParen)
		{
			if(yylval.semval==tok_Comma)
				continue;
			fprintf(efile, "%d\t", yylval.toknum);
			last++;
		}
		fprintf(efile, "\n");
		fprintf(tfile, "%d\t0\t%d\t0\n", HowManyBits(last)-1, last-1);
		/* skip tok_Semicolon */
		yylex();
    }
	fclose(tfile);
	fclose(efile);
	SemGlobal->hasTypes=1;
	SemGlobal->NCofNC=0;
	return 0;
}//ParseTypeDeclaration


int FindBaseTypeStringInPack( int toknum, char *typestr, char *looktype)
{
	FILE *typesfile;
	char line[16384], typespath[PATHSIZE];
	int len;
	len = strlen(SemGlobal->tmpactpath);
	strncpy(typespath, SemGlobal->tmpactpath, len-1);
	typespath[len-1]=0;
	strcat(typespath, ".tdf");
	typesfile=fopen(typespath,"rt");
	if(typesfile!=NULL)
	{
		while( fgets( line, 16383, typesfile))
		{
			int typenumber, typelength, leftlimit, rightlimit, parenttype;
			char typename[256], basetype[256]; /* useless, for (s)scan(f)ning only */ 
			
			sscanf(line,"%d%s%s%d%d%d%d", &typenumber, typename, basetype, &typelength,
				&leftlimit, &rightlimit, &parenttype);
			if(stricmp(looktype, typename))
				continue;
			sprintf( typestr,"%s", line);
			fclose(typesfile);
			return 1;
		}
	}
	return 0;
}//FindBaseTypeStringInPack



int BaseLookForUses(char *path, int toknum, char *typestr, char *looktype)
{
	FILE *srcf;
	char bufor[BUFSIZE];
	int isPaths=0;
	if((srcf=fopen(path, "rt"))==NULL)
		return -1;
	while(fgets(bufor, BUFSIZE, srcf))
	{
		if(bufor[0]=='#')
		{
			if(bufor[2]=='3' || bufor[2]=='7')
				isPaths=1;
			else
				isPaths=0;
			continue;
		}
		if(isPaths==1)
		{
			strcpy(SemGlobal->tmpactpath, bufor);
			if(FindBaseTypeStringInPack(toknum, typestr, looktype)==1)
			{
				fclose(srcf);
				return 1;
			}
		}
	}
	return 0;
}//BaseLookForUses

int BaseCutPath(int toknum, char *typestr, char *looktype)
{
	unsigned len, i;
	char path[PATHSIZE];
	sprintf(path, "%s.val", SemGlobal->tmpactpath);
	if(BaseLookForUses(path, toknum, typestr, looktype)==1)
		return 1;
	len=strlen(SemGlobal->tmpactpath);
	i=len;
	while(i>0)
	{
		if(SemGlobal->tmpactpath[i]=='\\')
		{
			SemGlobal->tmpactpath[i]=0;
			break;
		}
		i--;
	}
	if(i>8)
	{
		while(i>0)
		{
			if(SemGlobal->tmpactpath[i]=='_')
			{
				SemGlobal->tmpactpath[i]=0;
				break;
			}
			i--;
		}
	}
	if(!stricmp("toplevel", SemGlobal->tmpactpath))
		return -1;//zostalo tylko toplevel
	if(!stricmp("library", SemGlobal->tmpactpath))
		return -1;//zostalo tylko library (w pakiecie)
	return 0;
}//BaseCutPath


int FindBaseTypeString( int toknum, char *typestr, char *looktype)
{
	FILE *typesfile;
	char line[16384], typespath[PATHSIZE];
	int retval;
	sprintf(typespath, "%s.tdf", SemGlobal->tmpactpath);
	typesfile=fopen(typespath,"rt");
	if(typesfile!=NULL)
	{
		while( fgets( line, 16383, typesfile))
		{
			int typenumber, typelength, leftlimit, rightlimit, parenttype;
			char typename[256], basetype[256]; /* useless, for (s)scan(f)ning only */ 
			
			sscanf(line,"%d%s%s%d%d%d%d", &typenumber, typename, basetype, &typelength,
				&leftlimit, &rightlimit, &parenttype);
			if( typenumber != toknum)
				continue;
			sprintf(typestr, "%s", line);
			fclose(typesfile);
			return 1;
		}
	}
	retval=BaseCutPath(toknum, typestr, looktype);
	if(retval==-1)
		return -1;
	if(retval==1)//znaleziono typ w sciezce z use
		return 1;
	return FindBaseTypeString(toknum, typestr, looktype);
}//FindBaseTypeString



int FindBaseTypeInformation(int toknum, char *tokstr, char *typestr)
{
	decl_status.type_toknum=toknum;
	/***  INTEGER    ***/
	if(!stricmp(tokstr, "integer"))
    {
		int left, right, to_or_downto;
		int left_sign, right_sign;

		yylex();
		if( yylval.semval!=tok_RANGE) 
		{
			sprintf( typestr,"%d\t%d\t%d\t32\t-2147483647\t2147483647\t0",
				toknum, decl_status.Class, decl_status.mode);
			return 0;
		}
		/* get left limit */
		if( yylex()==tok_Minus)
		{
			left_sign=-1;
			yylex();
		}
		else
			left_sign=1;
		sscanf(yylval.tokstr, "%d", &left);
		left*=left_sign;
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			right_sign=-1;
			yylex();
		}
		else
			right_sign=1;
		sscanf(yylval.tokstr, "%d", &right);
		right*=right_sign;
		if( to_or_downto==tok_TO)
		{
			left=max(left,MIN_VHDL_INT);
			right=min(right,MAX_VHDL_INT);
			sprintf( typestr,"INT\t%d\t%d\t%d\t0",
			  HowManyBits(max(abs(right), abs(left))), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		else
		{
			left=min(left,MAX_VHDL_INT);
			right=max(right,MIN_VHDL_INT);
			sprintf( typestr,"INT\t%d\t%d\t%d\t0",
			  HowManyBits(max(abs(right), abs(left))), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		return 1;
    }

	/***   CHARACTER   ***/
	if(!stricmp(tokstr, "character"))
    {
		int left, right, to_or_downto;
		int left_sign, right_sign;
		yylex();
		if( yylval.semval!=tok_RANGE) 
		{
			sprintf( typestr,"%d\t%d\t%d\t8\t0\t255\t0",
				toknum, decl_status.Class, decl_status.mode);
			return 0;
		}
		/* get left limit */
		if( yylex()==tok_Minus)
		{
			left_sign=-1;
			yylex();
		}
		else
			left_sign=1;
		sscanf(yylval.tokstr, "%d", &left);
		left*=left_sign;
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			right_sign=-1;
			yylex();
		}
		else
			right_sign=1;
		sscanf(yylval.tokstr, "%d", &right);
		right*=right_sign;
		if( to_or_downto==tok_TO)
		{
			left=max(left,MIN_VHDL_INT);
			right=min(right,MAX_VHDL_INT);
			sprintf( typestr,"CHAR\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		else
		{
			left=min(left,MAX_VHDL_INT);
			right=max(right,MIN_VHDL_INT);
			sprintf( typestr,"CHAR\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		return 1;
    }
	
	/***     BIT      ***/
	if(!( stricmp(tokstr, "bit") && stricmp(tokstr, "std_ulogic") && stricmp(tokstr, "std_logic")))
    {
		int left, right, to_or_downto;
		int left_sign, right_sign;
		yylex();
		if( yylval.semval!=tok_RANGE) 
		{
			sprintf( typestr,"%d\t%d\t%d\t1\t0\t1\t0\t0",
				toknum, decl_status.Class, decl_status.mode);
			return 0;
		}
		/* get left limit */
		if( yylex()==tok_Minus)
		{
			left_sign=-1;
			yylex();
		}
		else
			left_sign=1;
		sscanf(yylval.tokstr, "%d", &left);
		left*=left_sign;
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			right_sign=-1;
			yylex();
		}
		else
			right_sign=1;
		sscanf(yylval.tokstr, "%d", &right);
		right*=right_sign;
		if( to_or_downto==tok_TO)
		{
			left=max(left,MIN_VHDL_INT);
			right=min(right,MAX_VHDL_INT);
			sprintf( typestr,"BIT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		else
		{
			left=min(left,MAX_VHDL_INT);
			right=max(right,MIN_VHDL_INT);
			sprintf( typestr,"BIT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		return 1;
    }
	
	/***   BOOLEAN    ***/
	if(!stricmp(tokstr, "boolean"))
    {
		int left, right, to_or_downto;
		int left_sign, right_sign;
		yylex();
		if( yylval.semval!=tok_RANGE) 
		{
			sprintf( typestr,"%d\t%d\t%d\t1\t0\t1\t0\t0",
				toknum, decl_status.Class, decl_status.mode);
			return 0;
		}
		/* get left limit */
		if( yylex()==tok_Minus)
		{
			left_sign=-1;
			yylex();
		}
		else
			left_sign=1;
		sscanf(yylval.tokstr, "%d", &left);
		left*=left_sign;
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			right_sign=-1;
			yylex();
		}
		else
			right_sign=1;
		sscanf(yylval.tokstr, "%d", &right);
		right*=right_sign;
		if( to_or_downto==tok_TO)
		{
			left=max(left,MIN_VHDL_INT);
			right=min(right,MAX_VHDL_INT);
			sprintf( typestr,"BIT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		else
		{
			left=min(left,MAX_VHDL_INT);
			right=max(right,MIN_VHDL_INT);
			sprintf( typestr,"BIT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		return 1;
    }

	/***  BIT_VECTOR ***/
	if(!( stricmp(tokstr, "bit_vector") && stricmp(tokstr, "std_ulogic_vector") && stricmp(tokstr, "std_logic_vector")))
    {
		int left, right, to_or_downto;
		
		yylex();
		if( yylval.semval != tok_LeftParen)
		{
			sprintf( typestr,"%d\t%d\t%d\t32\t0\t31\t0",
				toknum, decl_status.Class, decl_status.mode); 
			return 0;
		}
		/* get left limit */
		yylex();
		sscanf(yylval.tokstr, "%d", &left);
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		yylex();
		sscanf(yylval.tokstr, "%d", &right);
		if(to_or_downto==tok_TO)
			sprintf(typestr, "BVECT\t%d\t%d\t%d\t202",
				is_ge_zero(right-left+1), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		else
			sprintf(typestr, "BVECT\t%d\t%d\t%d\t202",
				is_ge_zero(left-right+1), /* is it null slice? */
				left, right
				); 
		/* skip ) */
		yylex();
		return 1;
    }

	/***   NATURAL    ***/
	if(!stricmp(tokstr, "natural"))
    {
		int left, right, to_or_downto;
		int left_sign, right_sign;
		yylex();
		if( yylval.semval!=tok_RANGE) 
		{
			sprintf( typestr,"%d\t%d\t%d\t31\t0\t2147483647\t0",
				toknum, decl_status.Class, decl_status.mode);
			return 0;
		}
		/* get left limit */
		if( yylex()==tok_Minus)
		{
			left_sign=-1;
			yylex();
		}
		else
			left_sign=1;
		sscanf(yylval.tokstr, "%d", &left);
		left*=left_sign;
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			right_sign=-1;
			yylex();
		}
		else
			right_sign=1;
		sscanf(yylval.tokstr, "%d", &right);
		right*=right_sign;
		if( to_or_downto==tok_TO)
		{
			left=max(left,MIN_VHDL_INT);
			right=min(right,MAX_VHDL_INT);
			sprintf( typestr,"INT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		else
		{
			left=min(left,MAX_VHDL_INT);
			right=max(right,MIN_VHDL_INT);
			sprintf( typestr,"INT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		return 1;
    }

	/***   POSITIVE    ***/
	if(!stricmp(tokstr, "positive"))
    {
		int left, right, to_or_downto;
		
		yylex();
		if( yylval.semval!=tok_RANGE) 
		{
			sprintf( typestr,"%d\t%d\t%d\t31\t1\t2147483647\t0",
				toknum, decl_status.Class, decl_status.mode);
			return 0;
		}
		/* get left limit */
		yylex();
		sscanf(yylval.tokstr, "%d", &left);
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		yylex();
		sscanf(yylval.tokstr, "%d", &right);
		if( to_or_downto==tok_TO)
		{
			left=max(left,MIN_VHDL_POSITIVE);
			right=min(right,MAX_VHDL_POSITIVE);
			sprintf( typestr,"INT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		else
		{
			left=min(left,MAX_VHDL_POSITIVE);
			right=max(right,MIN_VHDL_POSITIVE);
			sprintf( typestr,"INT\t%d\t%d\t%d\t0",
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		return 1;
    }
	
	/***    STRING   ***/
	if(!stricmp(tokstr, "string"))
    {
		int left, right, to_or_downto;
		yylex();
		if(yylval.semval != tok_LeftParen)
		{
			sprintf(typestr, "%d\t%d\t%d\t1024\t1\t1024\t0",
				toknum, decl_status.Class, decl_status.mode); 
			return 0;
		}
		/* get left limit */
		if( yylex()==tok_Minus)
		{
			semerror(ERRBADARRAYBOUNDS, NULL);
			yylex();
			left=1;
		}
		sscanf(yylval.tokstr, "%d", &left);
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			semerror(ERRBADARRAYBOUNDS, NULL);
			yylex();
			right=1;
		}
		sscanf(yylval.tokstr, "%d", &right);
		if( to_or_downto==tok_TO)
			sprintf( typestr,"STRING\t%d\t%d\t%d\t205",
				is_ge_zero(right-left+1), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		else
			sprintf( typestr,"STRING\t%d\t%d\t%d\t205",
				is_ge_zero(left-right+1), /* is it null slice? */
				left, right
				); 
		/* skip ) */
		yylex();
		return 1;
    }


	/* When type is not one of the predefined types...*/
	strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
	if(FindBaseTypeString(toknum, typestr, yylval.tokstr)==-1)
	{
		yylval.line=SemGlobal->lineno;
		fprintf(stderr, "Could not find type declaration!\n");
		fprintf(stderr, "line: %d\ttoken: %s\n", yylval.line, yylval.tokstr);
		return -1;
	}
	else
	{
		int lToknum, lBitsCnt, lRight, lLeft, lBaseElement;
		char lBaseStr[256], lSuperBaseStr[256];
		int left, right, to_or_downto;
		int left_sign, right_sign;
		sscanf(typestr, "%d\t%s\t%s\t%d\t%d\t%d\t%d", &lToknum, lBaseStr, lSuperBaseStr, &lBitsCnt, &lLeft, &lRight, &lBaseElement);
		yylex();
		if( yylval.semval!=tok_RANGE) 
		{
			if(yylval.semval!=tok_LeftParen)
			{
				sprintf(typestr, "%s\t%d\t%d\t%d", lSuperBaseStr, lBitsCnt, lLeft, lRight);
				return 0;
			}
			/* get left limit */
			yylex();
			sscanf(yylval.tokstr, "%d", &left);
			/* skip tok_TO, tok_DOWNTO */
			yylex();
			to_or_downto=yylval.semval;
			/* get right limit */
			yylex();
			sscanf(yylval.tokstr, "%d", &right);
			if( to_or_downto==tok_TO)
				sprintf( typestr,"%s\t%d\t%d\t%d\t%d",
				lSuperBaseStr,
				is_ge_zero(right-left+1), /* is it null slice? */
				min(left,right), max(left,right),
				lBaseElement
				); 
			else
				sprintf( typestr,"%s\t%d\t%d\t%d\t%d",
				lSuperBaseStr,
				is_ge_zero(left-right+1), /* is it null slice? */
				max(left,right), min(left,right),
				lBaseElement
				); 
			/* skip ) */
			yylex();
			return 1;
		}
		/* get left limit */
		if( yylex()==tok_Minus)
		{
			left_sign=-1;
			yylex();
		}
		else
			left_sign=1;
		sscanf(yylval.tokstr, "%d", &left);
		left*=left_sign;
		/* skip tok_TO, tok_DOWNTO */
		yylex();
		to_or_downto=yylval.semval;
		/* get right limit */
		if( yylex()==tok_Minus)
		{
			right_sign=-1;
			yylex();
		}
		else
			right_sign=1;
		sscanf(yylval.tokstr, "%d", &right);
		right*=right_sign;
		if( to_or_downto==tok_TO)
		{
			left=max(left,MIN_VHDL_INT);
			right=min(right,MAX_VHDL_INT);
			sprintf( typestr,"%s\t%d\t%d\t%d\t0",
				lSuperBaseStr,
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		else
		{
			left=min(left,MAX_VHDL_INT);
			right=max(right,MIN_VHDL_INT);
			sprintf( typestr,"%s\t%d\t%d\t%d\t0",
				lSuperBaseStr,
				HowManyBits(is_ge_zero(right-left)), /* is it null slice? */
				min(left,right), max(left,right)
				); 
		}
		return 1;
	}
	return 0;
}//FindBaseTypeInformation


void AddResolvedType(int typenumber, char *LastResName)
{
	if(SemGlobal->ResolvedCnt)
		SemGlobal->ListOfResolved=(RESTYPES*)realloc((RESTYPES*)SemGlobal->ListOfResolved, sizeof(RESTYPES)*(SemGlobal->ResolvedCnt+1));
	else
		SemGlobal->ListOfResolved=(RESTYPES*)malloc(sizeof(RESTYPES));
	SemGlobal->ListOfResolved[SemGlobal->ResolvedCnt].TypeNo=typenumber;
	strcpy(SemGlobal->ListOfResolved[SemGlobal->ResolvedCnt].FunName, LastResName);
	SemGlobal->ResolvedCnt++;
	return;
}




int ParseSubTypeDeclaration(void)
{
	FILE *tfile, *efile;
	char tpath[PATHSIZE], epath[PATHSIZE], mode[3], typestr[16384], idstr[NAMESIZE], basetokstr[NAMESIZE];
	char IntOrArray[6];
	int typenumber=0, basetypenumber=0, hasSpecialSlice;
	if(SemGlobal->hasTypes)
		strcpy(mode, "at");//jest juz plik z typami
	else
		strcpy(mode, "wt");//nie ma jeszcze tego pliku
	sprintf(tpath, "%s.tdf", SemGlobal->actpath);
	sprintf(epath, "%s.def", SemGlobal->actpath);
	tfile=fopen(tpath, mode);
	efile=fopen(epath, mode);
	
	assert(tfile);
	/* get type identifier */
	yylex();
	//fprintf(tfile, "%d\t%s\t", yylval.toknum, yylval.tokstr);
	typenumber=yylval.toknum;
	strcpy(idstr, yylval.tokstr);
	/* skip tok_IS */
	yylex();
	/* type definition begins */
	//yylex();
	basetypenumber=yylval.toknum;
	// Type description expected 
	NewGetTypeString(typestr);
	if(SemGlobal->IsResolvedFunction)
	{
		strcpy(basetokstr, yylval.tokstr);
		basetypenumber=yylval.toknum;
		AddResolvedType(typenumber, SemGlobal->LastResName); 
	}
	else
		sscanf(typestr, "%d", &basetypenumber);
	hasSpecialSlice=0;
	if( yylval.semval==tok_RANGE || yylval.semval==tok_LeftParen)
	{
		if(yylval.semval==tok_LeftParen)
			strcpy(IntOrArray, "ARRAY");
		else
			strcpy(IntOrArray, "INT");
		SemGlobal->EnumBaseType=basetypenumber;
		hasSpecialSlice=GetSliceOfTypeForSubtype(typestr);
	}
	if(hasSpecialSlice!=1)//doesn't has special slice i.e. A'range
	{
		char BaseTypeStr[256];
		int ValidBits, left, right, BaseType;
		fprintf(tfile,"%d\t%s\t", typenumber, idstr);
		strcpy(SemGlobal->tmpactpath, SemGlobal->actpath);
		if(FindLexemInformation(basetypenumber, typestr))
		{
			;//printf("%s\n", typestr);
		}
		if(SemGlobal->IsResolvedFunction)
		{
			yylex();
			if(yylval.semval==tok_Semicolon)
				SemGlobal->TypeCollected=2;
			if(basetypenumber==202)
			{
				fprintf( tfile, "BIT\t1\t0\t1\t0\t202\n");
			}
			else
			{
				FindTypeInformation(basetypenumber, basetokstr, typestr);
				ReduceTo6Cols(typestr);
				fprintf( tfile, "%s\n", typestr);
			}
			SemGlobal->IsResolvedFunction=0;
		}
		else
		{
			sscanf(typestr, "%s\t%d\t%d\t%d\t%d", BaseTypeStr, &ValidBits, &left, &right, &BaseType);
			if(typenumber!=215)
				fprintf( tfile, "%s\t%d\t%d\t%d\t0\t%d\n", BaseTypeStr, ValidBits, left, right, BaseType);
			else
			{
				if(right-left==1)
					ValidBits=1;
				fprintf( tfile, "%s\t%d\t%d\t%d\t0\t%d\n", BaseTypeStr, ValidBits, left, right, BaseType);
			}
		}
	}
	else//has special slice i.e. A'range
	{
		FILE *ncmpfile, *tmpncmpfile;
		char NotComputablePath[PATHSIZE], TmpNotComputablePath[PATHSIZE];
		char TmpLexemStr[NAMESIZE];
		int i, lBaseType, lMode, lTypeOf, Arg1No, Arg2No, OpenParenCnt;
		Arg1No=0;Arg2No=0;
		sprintf(NotComputablePath, "%s.ncp", SemGlobal->actpath);
		if(SemGlobal->hasNonComputables)
			ncmpfile=fopen(NotComputablePath, "at");
		else
			ncmpfile=fopen(NotComputablePath, "wt");
		SemGlobal->hasNonComputables=1;
		if(!ncmpfile)
			return -1;
		sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
		WriteLastLexemId(TmpLexemStr);
		Arg1No=SemGlobal->LastLexemId+200;
		fprintf(ncmpfile, "; %d\n", Arg1No);
		OpenParenCnt=0;
		for(i=0 ; i<SemGlobal->LexemsInListCnt ; i++)
		{
			if(SemGlobal->ListOfYY[i].semval==tok_LeftParen)
				OpenParenCnt++;
			if(SemGlobal->ListOfYY[i].semval==tok_RightParen)
			{
				if(OpenParenCnt<1)
					continue;
				OpenParenCnt--;
			}
			if(SemGlobal->ListOfYY[i].semval==tok_TO || SemGlobal->ListOfYY[i].semval==tok_DOWNTO)
			{
				sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
				WriteLastLexemId(TmpLexemStr);
				Arg2No=SemGlobal->LastLexemId+200;
				fprintf(ncmpfile, "114\tspecial_character:\t;\n");
				fprintf(ncmpfile, "; %d\n", Arg2No);
				OpenParenCnt=0;
			}
			else
			{
				char TmpStrDescr[NAMESIZE];
				LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
				fprintf(ncmpfile, "%s\n", TmpStrDescr);
				if(SemGlobal->LexemsInListCnt==2)
				{
					fprintf(ncmpfile, "224\tidentifier:\t'low\n");
					fprintf(ncmpfile, "114\tspecial_character:\t;\n");
					sprintf(TmpLexemStr, "__pbtmpid__%d", SemGlobal->LastLexemId+201);
					WriteLastLexemId(TmpLexemStr);
					Arg2No=SemGlobal->LastLexemId+200;
					fprintf(ncmpfile, "; %d\n", Arg2No);
					LexemStringDescr(SemGlobal->ListOfYY[i].toknum, TmpStrDescr);
					fprintf(ncmpfile, "%s\n", TmpStrDescr);
					fprintf(ncmpfile, "223\tidentifier:\t'high\n");
				}
			}
		}
		if(OpenParenCnt==1)
			fprintf(ncmpfile, "106\tspecial_character:\t)\n");
		fprintf(ncmpfile, "114\tspecial_character:\t;\n");
		fclose(ncmpfile);
		sprintf(TmpNotComputablePath, "%s.tnc", SemGlobal->actpath);
		
		if(SemGlobal->hasNonComputables)
			tmpncmpfile=fopen(TmpNotComputablePath, "at");
		else
			tmpncmpfile=fopen(TmpNotComputablePath, "wt");
		if(!tmpncmpfile)
			return -1;
			/* toknum - znany w czasie kompilacji
			* name - znane w czasie kompilacji
			* mode - znany w czasie kompilacji
			* typeof - znany w czasie kompilacji
			* nrofbits - nieznany w czasie kompilacji
			* left -  nieznany w czasie kompilacji
			* right - nieznany w czasie kompilacji
			* jesli right=0, to left okresla 
		*/
		sscanf(typestr, "%d\t%d\t%d", &lBaseType, &lMode, &lTypeOf);
		fprintf(tmpncmpfile, "%d\t%s\t%d\t%d\t%d\t0\t%d\t%d\t%s\n", typenumber, idstr, lBaseType, 12, lTypeOf, Arg1No, Arg2No, IntOrArray);
		fclose(tmpncmpfile);
		FreeListOfYY();
	}
	//FindBaseTypeInformation(yylval.toknum, yylval.tokstr, typestr);
	//fprintf(tfile,"%s\t%d\n", typestr, basetypenumber);
	//yylex();
	fclose(tfile);
	fclose(efile);
	SemGlobal->hasTypes=1;
	return 0;
}//ParseSubTypeDeclaration


int HowManyBits( unsigned number)
{
	int i;
	unsigned long exponent=1L;
	if( number <= 0)
		return 0;
	for( i=0; i<32; i++)
		if(number < exponent)
			return i+1; 
		else 
			exponent <<=1;
	if(number==4294967294L)
		return 32;
	return -1;
}//HowManyBits


int HowManyBitsInt(int left, int right)
{
	int i, sign=0;
	unsigned long exponent=1L;
 	unsigned number= max(abs(right), abs(left));
	if(left<0 || right<0)
	{
		sign=1;
		if(left<0 && abs(left)>abs(right))
		{
			sign=0;
		}
		if(right<0 && abs(right)>abs(left))
		{
			sign=0;
		}
	}
	if( number <= 0)
		return 0;
	for( i=0; i<32; i++)
	{
		if(number < exponent)
			return i+sign; 
		else 
			exponent <<=1;
	}
	if(number==4294967294L)
		return 32;
	return -1;
}//HowManyBitsInt
