#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#ifndef _MSC_VER
  #include <unistd.h>
#else
  #include <direct.h>
#endif
#include "tmpvar.h"
#include "konwert.h"

static int first_tmp_number;
static char sourcedir[256];
static char consfilename[256];
static FILE *varfile;
static int tmp_var_generator_is_already_initialised=0;
/*
 * For local use only
 */
int NumberOfId(char *);
void GenerateNewConstant(int , char *); 

void InitTmpVarGenerator( char *varfilename, char *consfname)
{
	char line[256];
	if( tmp_var_generator_is_already_initialised)
		return;
	tmp_var_generator_is_already_initialised=1;
	varfile=fopen( varfilename,"rt+");
	assert(varfile);
	assert(!fseek(varfile,0L,SEEK_SET));
	getcwd(consfilename,255);
	strcat(consfilename,"/");
	strcat(consfilename,consfname);
#ifndef _MSC_VER
	getcwd( sourcedir, 255);
#else
	_getcwd( sourcedir, 255);
#endif
	while( fgets(line,255,varfile))
		sscanf(line,"%d",&first_tmp_number);
	
	first_tmp_number+=200;
}

int TmpVarNumber( char *name)
{
	if( !tmp_var_generator_is_already_initialised)
    {
		printf("\aStrange internal error:\n");
		printf("Temporary variable generator is not initialised!\n");
		printf("Abnormal program termination!\n");
		exit(-1);
    }
	if( name[0]!='\0')
		return NumberOfId(name);
	sprintf(name,"tmp__id_%d_",first_tmp_number);
	fprintf(varfile,"%d\t%s\n",first_tmp_number-200,name);
	first_tmp_number++;
	return first_tmp_number-1;
}

int NumberOfId(char *name)
{
#if 0
#define ALLOC
#endif
#ifndef ALLOC
	char line[1024], probe[256];
#else
	char *line = malloc(1024),*probe = malloc(256);
#endif
	int number, found=0;
	
	assert(!fflush(varfile));
	assert(!fseek(varfile,0L,SEEK_SET));
	while( fgets(line,1023,varfile)!=NULL)
    {
		sscanf(line,"%d\t%s",&number, probe);
		if( !stricmp(probe,name))
		{
			found=1;
			break;
		}
    }
	assert(!fflush(varfile));
	//SkipFile(varfile);
	assert(!fflush(varfile));
	if( !found)
    {
		number=first_tmp_number-200;
		fprintf(varfile,"%d\t%s\n",number,name);
		GenerateNewConstant(number+200,name);
    }
	first_tmp_number++;
#ifdef ALLOC
	free(line);
	free(probe);
#endif
	return number+200;
}

void GenerateNewConstant(int number, char *name) 
{
	FILE *cfile=fopen(consfilename,"rt+");
	FILE *localcfile=fopen("port.var","rt+");
	char constdescr[1024];
	char *bit_string=anytobin(name,10);
	
	assert( cfile || localcfile);
	sprintf(constdescr,"%d\t%s\t201\t5\t0\t%d\t0\t%d\t%s\n",
		number,name,(int)strlen(bit_string),(int)strlen(bit_string)-1,bit_string);
	if(cfile)
    {
		//SkipFile(cfile); 
		fprintf(cfile,"%s",constdescr);
		fclose(cfile);
    }
	
	if(localcfile)
    {
		//SkipFile(localcfile);
		fprintf(localcfile,"%s",constdescr);
		fclose(localcfile);
    }
}
int IdString(int lexem, char *idstring)
{
	int number;
	char line[1024], probe[1024];
	assert(!fseek(varfile,0L,SEEK_SET));
	while( fgets(line,1023,varfile)!=NULL)
    {
		sscanf(line,"%d\t%s",&number, probe);
		if(lexem==number+200)
		{
			sprintf(idstring,"%s",probe);
			return 0;
		}
    }
	return 1;
}

