#include <stdio.h>
#include "Vhdl_tab.h"

#define __DEVEL__VER__ONLY__ 1

#define TYPEARCH 1
#define TYPEPACK 2


#define ALIASV		4
#define ARCHV		7
#define ASSERTV		9
#define ATTRIBV		10
#define BEGINV		11
#define BLOCKV		12
#define BODYV		13
#define CASEV		16
#define COMPONV		17
#define CONFV		18
#define CONSTANTV	19
#define ENDV		24
#define ENTITYV		25
#define FORV		28
#define FUNCV		29
#define GENERATEV	30
#define GENERICV	31
#define IFV			34
#define INV			36
#define INOUTV		38
#define ISV			39
#define LOOPV		44
#define MAPV		45
#define OUTV		58
#define PACKV		59
#define PORTV		60
#define PROCV		62
#define PROCESSV	63
#define RECORDV		66
#define SIGNALV		76
#define SHAREDV		77
#define SUBTYPEV	82
#define TYPEV		86
#define USEV		90
#define VARV		91
#define WHILEV		94
#define LEFTBRV		105
#define RIGHTBRV	106
#define COMMAV		109
#define DOTV		111
#define COLONV		113
#define SEMICV		114
#define IMPLICV		166
#define ASSIGNV		168
#define DOUBLETRV	172
#define IDENTV		201

#define BUFSIZE		16384
#define SBSIZE		256
#define PATHSIZE	1024
#define NAMESIZE	256

//predefined types lexem values
#define INTEGERLV	201
#define BITLV		202
#define BITVECTORLV	203
#define BOOLEANLV	204
#define CHARLV		205
#define STRINGLV	206
#define NATURALLV	207
#define POSITIVELV	208
#define STDULOGICLV	209
#define STDLOGICLV	210
#define SULVECTORLV	211
#define SLVECTORLV	212
#define SIGNEDLV	213
#define UNSIGNEDLV	214
#define SMALL_INTLV	215

#define GENERICLV	16
#define TYPELV		9
#define SUBTYPELV	12


//predefined types of resolution
#define WIREDAND	1
#define WIREDOR		2
#define THREESTATE	3

#define IGNOREDTYPE -3

struct actualmodifiers
{
	int origlexno;				//numer lexemu orginalnego
	int modlexno;				//numer lexemu po modyfikacji
	char ModifiedName[NAMESIZE];//Nazwa po modyfikacji i rozszerzeniu
	int level;					//poziom na ktorym modyfikacja wystepuje
	int isInArchitecture;		//czy dana nazwa znajduje sie w architekturze
	char *ComponName;			//Nazwa komponentu w ktorym sie modyfikacja odbywa
	char *ProcessName;			//ewentualna nazwa procesu w ktorym sie modyfikacja odbywa
};

typedef struct actualmodifiers MODIFIERS;

struct entity
{
	char name[SBSIZE];		//nazwa jednostki
	char archname[SBSIZE];	//nazwa architektury pasujacej do jednostki
	int isconfig;			//czy istnieje jawna konfiguracja
	int isarch;				//czy odczytano juz jakas pasujaca architekture
	int isentity;			//czy odczytano encje (i jej numer w index.idx), w przypadku gdy najpierw odczytana architektura
	int entityno;			//numer jednostki w index.idx
	int archno;				//numer architektury w index.idx
	int isTopLevel;			//czy dana jednostka jest jednostka toplevel
	int portcnt;			//ilosc portow zadeklarowana w danej jednostce
	int *portids;			//tablica identyfikatorow portow
	int *isbuffers;			//tablica dla portow mowiaca o tym, czy jest to buffer
	int HasResolvFile;		//czy jednostka ma juz plik .res
	int modifierscnt;		//ilosc modyfikatorow nazw odpowiadajacych danej jednostce
	MODIFIERS *modifiers;	//tablica modyfikatorow nazw odpowiadajacych danej jednostce
};

struct generic
{
	int LexemId;
	int TypeOf;
	int left, right, lenght;
	int value;
	char *bitvalue;
	char *name;
};

struct fproto
{
	int parcnt;				//liczba parametrow danej funkcji
	char name[SBSIZE];		//nazwa funkcji
	char fname[PATHSIZE];	//nazwa pliku z prototypem
	int hasBody;			//czy do prototypu pasuje jakas funkcja z package body
	int *params;			//tablica typow paramterow wywolania
	int retType;			//numer typu zwracanego przez funkcje
	int TypeOf;				//2-funkcja, 4-procedura
	int ResolvingType;		//typ rezolucji (0-nie jest funkcja rezolucji, 1,2,3-jest)
};

struct component
{
	char name[SBSIZE];		//nazwa komponentu
};

struct ChangedComponent
{
	char name[SBSIZE];		//nazwa komponentu
	int modifierscnt;		//ilosc modyfikatorow nazw odpowiadajacych danemu componentowi
	MODIFIERS *modifiers;	//tablica modyfikatorow nazw odpowiadajacych danemu componentowi
};

struct arch
{
	char archname[SBSIZE];	//nazwa architektury
	char entityname[SBSIZE];//nazwa jednostki
	int archno;				//numer architektury w index.idx
};

struct config
{
	char configname[SBSIZE];	//nazwa konfiguracji
	char entityname[SBSIZE];	//nazwa jednostki
	char archname[SBSIZE];		//nazwa architektury dla tej do jednostki
};

struct usepath
{
	char path[PATHSIZE];
};

struct usenfound
{
	char path[PATHSIZE];		//gdzie wstawic ewentualnie pozniej
	char useclause[BUFSIZE];	//odczytany wyglad use
	int issth;					//czy jest odczytana jednostka, architektura lub pakiet po use
	int lineno;					//numer linii z use (przy bledzie)
	char filename[PATHSIZE];	//nazwa pliku z use (przy bledzie)
};

struct allfiles
{
	char *path;
};

struct prcslist
{
	char *name;
};


struct aliasinf
{
	char left[NAMESIZE];
	int  rightlen;
	YYSTYPE *right;
};

struct allnames
{
	char *varname;			//nazwa przechowywana na liscie
	int level;				//poziom na ktorym nazwa wystepuje
	char *compon;			//ewentualna nazwa komponentu, jesli nazwa wystepuje w komponencie
};


struct restypes
{
	int TypeNo;				//numer typu resolved
	char FunName[NAMESIZE];	//nazwa odpowiadajacej mu funkcji
	int ResMethod;			//sposob obliczania
};

struct counter
{
	int real;				//rzeczywista liczba elementow
	int last;				//ostatnio zaalokowana liczba elementow
};

typedef struct entity ENTITY;
typedef struct component COMPONENT;
typedef struct ChangedComponent CHANGEDCOM;
typedef struct arch ARCH;
typedef struct config CONFIG;
typedef struct usepath USEPATH;
typedef struct usenfound USENFOUND;
typedef struct allfiles ALLFILES;
typedef struct prcslist PRCSLIST;
typedef struct fproto FPROTO;
typedef struct generic GENERIC;
typedef struct aliasinf ALIASINF;
typedef struct restypes RESTYPES;
typedef struct allnames ALLNAMES;
typedef struct counter COUNTER;

struct PBGLOBAL
{
	FILE *srcf;					//odczytywany plik z leksemami
	FILE *indexf;				//plik z indeksem
	int indexno;				//numer kolejnego zapisu do pliku z indeksem
	int lineno;					//numer biezacej linii
	int errcnt;					//ilosc bledow
	char actfile[SBSIZE];		//aktualnie przetwarzany plik
	char actroot[SBSIZE];		//korzen aktualnie przetwarzanej czesci drzewa
	char actEntityContext[SBSIZE];//nazwa jedostki dla ktorej aktualnie jest przetwarzana architektura
	char actProcessContext[SBSIZE];//nazwa aktualnie przetwarzanego procesu
	ENTITY *entities;			//wszystkie znalezione jednostki
	COMPONENT *components;		//wszystkie znalezione  nazwy komponentow
	CHANGEDCOM *ChangedCom;		//Komponenty zawierajace zmodyfikowane nazwy
	char  actcompo[NAMESIZE];	//nazwa aktualnie przetwarzanego komponent
	ARCH *archs;				//wszystkie znalezione architektury
	CONFIG *configs;			//wszystkie znalezione konfiguracje jednostek
	USEPATH *usepaths;			//wszystkie znalezione sziezki z use
	USENFOUND *usesnfound;		//wszystkie znalezione sziezki z use
	int ileencji;				//ilosc znalezionych jednostek
	int componcnt;				//ilosc znalezionych nazw componentow
	int ChangedComcnt;			//ilosc znalezionych componentow ze zmodyfikowanymi nazwami
	int configcnt;				//ilosc znalezionych configuracji
	int archcnt;				//ilosc znalezionych architektur
	int pathcnt;				//ilosc znalezionych sciezek z use
	int nfoundcnt;				//ilosc nie znalezionych sciezek z use
	int roottype;				//typ aktualnego rodzica
	char rootsname[SBSIZE];		//poczatek nazwy dodatkowej dla sygnalu
	int varlevel;				//ile poziomow dodatkowej nazwy
	char rootvname[SBSIZE];		//poczatek nazwy dodatkowej dla zmiennej
	int isIEEE1164avail;		//czy jest dostepny pakiet std_logic
	char actpath[PATHSIZE];		//sciezka w ktorej nalezy zapisywac plik z typami
	char tmpactpath[PATHSIZE];	//tymczasowa sciezka z ktorej nalezy odczytywac plik z typami
	int hasTypes;				//Czy biezacy zasieg posiada juz plik z typami
	int hasNonComputables;		//Czy w biezacym pliku sa jakies stale niemozliwe do obliczenia w czasie kompilacji
	ALLFILES *AllFiles;			//nazwy wszystkich plik w odpowiedniej kolejnosci
	int AllFilesCnt;			//ilosc wszystkich plikow z leksemami
	int PackFound;				//czy znaleziono pakiet
	int NoPackFilesCnt;			//ilosc plikow nie zawierajacych pakietow
	ALLFILES *NoPackFiles;		//pliki nie zawierajace pakietow
	int PackFilesCnt;			//ilosc plikow zawierajacych pakiety
	ALLFILES *PackFiles;		//pliki zawierajace pakiety
	char LastFoundName[SBSIZE];	//nazwa ostatnio znalezionego procesu, procedury lub funkcji
	int LastFoundValue;			//wartosc ostatnio znalezione procedury lub funkcji
	int LastReturnValue;		//wartosc ostatnio znalezionego typu zwracanego przez funkcje
	char LastReturnString[512];	//wartosci semantyczne ostatnio znalezionego typu zwracanego
	FILE *errfile;				//plik z bledami
	int LastFunctionNo;			//numer ostatnio utworzonej nazwy tymczaowej dla funkcji lub procedury
	int LastLexemId;			//numer ostatniego lexemu
	int DoesLastIsBuffer;		//czy ostatni znaleziony opis portu to buffer
	int protoscnt;				//ilosc prototypow funkcji
	FPROTO *fprotos;			//wskaznik na informacje semantyczne o prototypach funkcji
	int defaultmode;			//domyslny tryb dla informacji semantycznej
	YYSTYPE *ListOfYY;			//lista leksemow do przechowywania
	int LexemsInListCnt;		//liczba lexemow w liscie je przechowujacej
	GENERIC *ListOfGenerics;	//lista wartosci dla genericsow w aktualnej jednostce
	int GenericCnt;				//licznik generic w jednostce
	int isRightParenAlreadyRead;//czy jest juz odzczytany prawy nawias (uzywany w przypadku genericsow w nawiasach)
	YYSTYPE *ListForAlias;		//lista lexemow dla ostatniego aliasu
	ALIASINF *FullListForAlias;	//lista lexemow dla wszystkich aliasow
	int AliasCnt;				//liczba lexemow na liscie
	int ProcessCnt;				//liczba procesow w biezacym zasiegu
	int BlockCnt;				//liczba blokow w biezacym zasiegu
	int isInValFile;			//czy wartosc semantyczna znajduje sie pliku .val
	int isInPackage;			//czy znajdujemy sie w czesci deklaracyjnej pakietu
	PRCSLIST *ListOfPrcs;		//lista procesow w biezacym zasiegu
	PRCSLIST *PrcsNames;		//lista procesow we wszystkich zasiegach
	PRCSLIST *ListOfBlocks;		//lista blokow w biezacym zasiegu
	PRCSLIST *BlockNames;		//lista blokow we wszystkich zasiegach
	int EnumBaseType;			//Numer typu wyliczeniowego, ktory jest typem bazowym dla slice'a
	char basetype[SBSIZE];		//Nazwa Typu bazowego znalezionego przez FindTypeString
	int IsSTLACompiled;			//Czy jest kompilowany pakiet std_logic_arith
	int IsParentNonComputable;	//Czy typ signalu jest jeszcze nie obliczony
	int IsResolvedFunction;		//Czy jest to funkcja typu resolved
	char LastResName[NAMESIZE];	//Nazwa Ostatnio znalezionej funkcji rezolucji
	int LastResolvedType;		//Typ ostatnio znalezionej funkcji typu resolved (wired_and, wired_or, threeState)
	RESTYPES *ListOfResolved;	//Lista typow resolved
	int ResolvedCnt;			//ilosc typow na liscie resolved
	int NCofNC;					//czy typ nonComputable zawiera inny typ noncomputable
	int isComponentPort;		//czy parsowany jest typ komponentu
	int TypeCollected;			//czy pobrano caly typ (do srednika lub nawiasu)
	char LastFullType[BUFSIZE];	//Ostatnio znaleziona sciezka do typu
	char LastTypeName[BUFSIZE]; //Nazwa ostatnio znalezionego typu
	int LastIsPrototype;		//Czy ostatnia funkcja jest prototypem
	int GuardCnt;				//liczba dotychczasowych guardow
	ALLNAMES *NamesToCheck;		//Nazwy zmiennych sygnalow itp. do przejrzecznia przy modyfikacji
	int NamesCnt;				//liczba nazw w calym zrodle
	MODIFIERS *Modifiers;		//Tablica modyfikatorw w aktualnym zakresie
	COUNTER ModifiersCnt;		//liczba modyfikowanych nazw w calym zrodle
	int isArchitectureParsed;	//Czy aktualnie jest przetwarzana architektura
};

void semerror(int, char *);
int getvalue(char *, FILE *);
void getname(char *, char *);
void ReadToSemiC(void);
void ReadToIsOrSemiC(void);
void WriteLastLexemId(char *);
int FindLastLexemId(void);
int LexemStringDescr( int, char *);
void DeleteLastChar(char *);
int GetSliceOfType(char *);
int GetSliceOfTypeForSubtype(char *);
int GetSliceOfTypeForEntity(char *, int);
int GetSliceOfTypeForArray(char *, int *);
int GetRangeForArray(char *, int);
int GetOnlyType(char *);
int BlockParse(char *, int, char *);
int NoNamedGenerateParse(char *, int, char *);
int AddToProcessList(char *);
int AddToBlockList(char *);
int ProcessParse(char *, int, char *);
void CopyToSemicolon(FILE *);
void CopyPortMap(FILE *, char *);
void NewComponentName(char *);
int NoNamedProcessParse(char *destpath, int level);
void NextYY(void);
void FreeListOfYY(void);
void ReduceTo6Cols(char *);
int ValueFromLine(char *, int *);
void NewEntityPort(int *, char *);
void CheckNamesInEntity(int *, char *);
void CheckNewName(char *, int *, int);
void semwarn(char*);
